<p>Auch der WS-Reporter kommt in der Regel nicht ohne eine spezielle Datenaufbereitung aus. 
Die operativen Systeme sollen durch die Abfragen des Reportings nicht beeinträchtigt werden,
und umgekehrt sollen die Ergebnisse zumindest eine Zeit lang reproduzierbar bleiben, die Daten 
also nur zu bestimmten Zeiten aktualisiert werden.</p>
<p>Im Unterschied zu manchen anderen Systemen und zur Praxis in vergangenen Zeiten, sollen 
aber Redundanzen möglichst vermieden werden, auch wenn manche Aggregationen für akzeptable
Antwortzeiten weiterhin erforderlich sind. Für das Reporting unterscheiden wir zwischen 
"Werten", "Zeilen" und "Filter". Unter "Werten" verstehen wir alle Daten, die für die Reports
aggregiert werden (Summen, Mittelwerte, Minimum, Maximum usw.). Unter "Zeilen" verstehen wir 
alle Daten (Merkmale), nach denen diese Werte aggregiert werden können. "Filter" wiederum sind
Konstrukte zur Selektion der Daten. Sie können sich auf die Werte von "Zeilen" beziehen, aber
auch komplexe Sachverhalte umfassen - alles was in einer SQL-Where-Klausel formuliert werden kann.</p>
<p>Basis des Reportings ist die unterste Ebene, auf denen die Werte vorliegen. Die Strukturen für
höhere Aggregationsebenen werden in speziellen Tabellen, "Dimensionen", gespeichert und bei Bedarf
in der Abfrage verwendet. Beispielsweise werden die Ertragsdaten und weitere Kennzahlen in der Demo 
auf der Ebene Kundennummer, Produkt und Berichtsmonat gespeichert. Als Dimensionen kommen dann u.a. hinzu:</p>
<ul>
<li> Konzern-Struktur: die Zusammenfassung von Kundennummern zu Firmen und Konzernen,</li>
<li> Betreuung: die Zuordnung von Betreuern zu Konzernen,</li>
<li> Betreuer: die Betreuer und ihre Zuordnung zur Geschäftsstelle, in der sie arbeiten,</li>
<li> Vertriebsstruktur: Die Zuordnung von Geschäftsstellen zu Regionen und Gebieten,</li>
<li> Produktstruktur: Die Zusammenfassung von Produkten zu Produktgruppen und Produktbereichen.</li> 
</ul> 
<p>Alle Dimensionen werden in separaten Tabellen gespeichert, wodurch das Datenvolumen, vor allem aber auch
das für eine Abfrage transferierte Datenvolumen in Grenzen gehalten werden kann. Während früher die
vielen erforderlichen Joins zu erheblichen Performance-Einbußen geführt hätten, ist bei modernen 
Massenspeichern, Solid State Drives (SSD), die zu übertragende Datenmenge das wichtigste Kriterium
für die Antwortzeiten. Und auch dabei können im vergleich zu den früher verwendeten Festplatten
wesentlich größere Mengen schnell übertragen werden.</p>
<p>Trotzdem sind Aggregationen auf höhere Ebenen erforderlich. In der Demo sind das vor allem:</p>
<ul>
<li> Year-to-Date-Werte für die Abfrage von Stichtagen,</li>
<li> Summen auf Betreuer-Ebene,</li>
<li> Summen auf der Ebene Geschäftsstelle bei vielen Betreuern.</li>
</ul>
<p>Bei der Konzeption dieser Aggregate sollte die Häufigkeit, mit der diese Ebenen für das Reporting
ausreichend sind, im Vordergrund stehen. Dazu können auch Anforderungen aus der Historisierung kommen
(siehe dort).</p>
<h4>Hinweis zur Verwendung von Indizes</h4>
<p>Bei der Erstellung der Demo hat sich gezeigt, dass Indizees mit geringer Kardinalität die Antwortzeiten
vervielfachen können. Dazu mehr unter "Hinweise und Probleme".</p> 