<p>Dimensionen ersetzen die Verknüpfung von Daten für Zeilen, Spalten und Filter
in Datenbank-Views.</p>
<h4>Einführung</h4>
<p>Während viele Reporting-Tools genau eine Tabelle (oder einen "Datenwürfel") verlangen,
können im WS-Reporter "Dimensionen" definiert werden, die bei Bedarf (und nur bei Bedarf)
in der Abfrage verknüpft werden.</p>
<p>Das einfachste Beispiel sind Langtexte zu Schlüsselwerten. Solange die Zeile im konkreten
Report nicht benötigt wird, werden auch die Texte nicht benötigt. Nur wenn sie im Report 
angezeigt werden kommt es zu einem <i>left join</i> mit der Schlüsseltabelle für die Texte.
Auch die Produkthierarchie ist in der Demo als Dimension mit den Schlüsseln und Texten für
Produkt, Produktgruppe und Produktbereich implementiert. Nur wenn ein Element aus dieser
Hierarchie benötigt wird, wird diese Hierarchie-Tabelle in der Abfrage verwendet. Wenn nach
einem Element selektiert wird, kommt es zu einem (inner) join.</p>
<p>Dimensionen sind eine besondere Variante einer Datenquelle im WS-Reporter. Sie werden
bei der Erstellung normaler Datenquellen verwendet. Dabei werden alle relevanten Daten
aus der Dimension in die Definition der Datenquelle übernommen. Eine spätere Änderung der 
Dimension wirkt sich deshalb nicht auf zuvor erstellte Datenquellen aus. Andererseits kann 
die Datenquelle so exportiert und in einer anderen Umgebung importiert werden, ohne dass
in der neuen Umgebung auch die verwendeten Dimensionen importiert werden.</p> 
<h4>Erstellen einer Dimension</h4>
<p>Eine Dimension wird wie eine normale Datenquelle erstellt. Allerdings enthält sie
nur Zeilen und Filter, keine Werte und keine verknüpfbaren Datenquellen. An dieser 
Stelle kann auch keine andere Dimension mit einem Element dieser Definition
verknüpft werden. Das funktioniert erst bei der Erstellung der normalen Datenquelle.</p>
<p><b>Der Typ der Quelle "Dimension" muss immer zuerst eingestellt werden.</b>
Dadurch erhalten die Select-Audrücke der Zeilen und Filter beim Initialisieren den
Tabellen-Alias "dim.".
Nach der Spezifikation der Zeilen muss eine Zeile als "Key für die Verknüpfung"
ausgewählt werden.</p>
<p>Bei der Erstellung von Dimensionen muss in den Select-Ausdrücken, "Select-Name oder Ausdruck"
und "Select für Anzeige", der Tabellen-Alias "dim." verwendet werden. Dasselbe gilt auch für 
die Ausdrücke in Sonder-Filter. Dieser Alias wird bei
der Verwendung der Dimension so ersetzt, dass gültige und eindeutige Select-Abfragen entstehen.</p>     
<h4>Verwenden einer Dimension</h4>
<p>Beim Erstellen der Datenquelle werden Dimensionen im Kasten verknüpfte Dimensionen eingetragen.
Das Fragezeichen für die Auswahlliste funktioniert wie gewohnt. Jede Dimsion erhält eine Nummer. 
In der Liste werden der Name und der Key zum Verknüpfen angezeigt. Jetzt muss die Dimension mit 
der Datenquelle verknüpft werden. Bei der Standard-Verknüpfung wird der Key über die gleichnamige
Zeile in der Datenquelle verknüpft. Bei der erweiterten Verknüpfung kann die Zeile über eine 
Drop-Down-Liste ausgewählt werden. In beiden Fällen werden alle anderen Zeilen und Filter
aus der Dimension in der Datenquelle automatisch angelegt. Wenn eine Zeile oder Filter gleichen 
Namens bereits existiert, erhält das Neue Element die Nummer der Dimension vor dem Namen.
<b>In diesem Fall sollte das Element so umbenannt werden, wie es bei der Verknüpfung mit anderen Datenquellen 
verwendet wird.</b> In der Regel erhält die Dimension in der anderen Datenquelle eine andere
Nummer, so dass die Verknüpfung über Nummer und Origimnal-Name nicht funktioniert.</p>
<p>Eine Dimension kann auch mit einer Zeile aus einer vorher verknüpften Dimension verknüpft werden.</p>
<h4>Umbennennen von Zeilen und Filter</h4>
<p>Die automatische Namens-Vergabe erfordert die Möglichkeit, die neu erstellten Elemente (Zeilen und Filter) 
umzubenennen. Dazu kann auf die Überschrift im Metadaten-Editor geklickt werden. Es erscheint dann
eine Zeile zum Umbenennen des Elements.</p> 
<h4>Aktualisieren der Datenquelle aus Dimensionen</h4>
<p>Es kommt vor, dass eine Zeile oder ein Filter aus einer bereitszugeordneten Dimension
nachträglich übernommen werden muss. Das kann daran liegen, dass eine Dimension nach ihrer 
Zuordnung erweitert wurde, oder daran, dass eine vormals gelöschte Zeile doch wieder benötigt wird. Mit 
der Schaltfläche "hinzufügen" hinter einem Dimension-Eintrag wird eine Anzeige aller Zeilen und Filter 
dieser Dimension aufgerufen, aus der über die Schaltfläche "eintragen" einzelne Zeilen oder Filter neu 
in die Datenquelle übernommen werden können. In dieser Anzeige kann auch die Information zur Historisierung
dieser Dimension aktualisiert werden.</p>