<p>Beim Aufbau der Demo hat sich gezeigt, dass die MariaDB 
durch scheinbar sinnvolle Indizes auch ausgebremst werden kann. Im folgenden
beispiel ist für berichtsmonat ein einfacher BTREE-Index erstellt, während 
berichtszeitraum keinen Index hat.<br>
Die Tabelle hat 31,3 Mio. Datensätze, veerteilt auf 28 Berichtsmonate, 
was ca. 3,6 GiB Daten ergibt. 
<br>


Die Antwortzeiten zeigen, dass bei Intervallen
(between 2021 and 2022) der Index zu die Antwortzeit mehr als verdoppelt.
</p>

<pre>
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE 1;
-- Die Abfrage dauerte 8.3356 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE berichtsmonat = 2021.05;
-- Die Abfrage dauerte 1.5334 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE berichtszeitraum = 2020.09;
-- Die Abfrage dauerte 6.7441 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE berichtszeitraum between 2021 and 2022;
-- Die Abfrage dauerte 8.0562 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE berichtsmonat  between 2021 and 2022;
-- Die Abfrage dauerte 19.7886 Sekunden


</pre>
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE 1;
-- Die Abfrage dauerte 8.3356 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE berichtsmonat = 2021.05;
-- Die Abfrage dauerte 1.5334 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE gueltig = '2020-09-30';
-- Die Abfrage dauerte 6.7441 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE gueltig between '2021-01-01' and '2021-12-31';
-- Die Abfrage dauerte 8.0562 Sekunden
SELECT sum(nettoertrag) FROM `Monatswerte` WHERE berichtsmonat  between 2021 and 2022;
-- Die Abfrage dauerte 19.7886 Sekunden
