<p>Besondere Aufmerksamkeit ist bei den Namen in verknüpfbaren
Quellen erforderlich: Die Namen in den Quellen müssen zueinander passen. Sinnvoll wäre deshalb,
für Quellen, die zu einem Thema gehören ein zentrales Verzeichnis anzulegen, in dem beschrieben
wird, wie die internen Namen verwendet werden.
</p>
<h4>Zeilen</h4>
<p>Die Daten werden über die ausgewählten Zeilen-Variablen verknüpft. 
Ein Problem entsteht dann, wenn in der führenden Quelle eine Nummer und 
die Bezeichnung vorhanden sind, in der verknüpften Quelle aber nur die Nummer. 
Wenn jetzt nur die Bezeichnung angezeigt werden soll, funktioniert die 
Verknüpfung nicht.</p> 
<p>Eine Lösung wäre eine kombinierte Spalte, die intern
die Nummer verwendet und nur zur Anzeige die Bezeichnung. Dann könnte 
in der verknüpften Quelle eine gleichnamige Spalte mit der Nummer 
angelegt werden, damit die Verknüpfung funktioniert. Aktuell ist 
es aber sinnvoller, in beiden Quellen Views mit den erforderlichen 
Spalten zu verwenden.</p> 
<p>Eine konzepitionelle Lösung wäre die Einführung von "Dimensionen",
die sich über den Primärschlüssel, im Beispiel die Nummer, automatisch 
mit allen Quellen verknüpfen.
</p> 
<h4>Filter</h4>
<p>Bei verknüpften Quellen werden Selektionen über die ausgewählten Filter
vererbt. Auch hier ist darauf zu achten, dass die Filter, die bei einer 
Datenquelle üblicherweise verwendet werden, in den verknüpfbaren Quellen 
passend vorhanden sind. Zusätzlich ist hier auf die entsprechenden Indizes
in der Datenbank zu achten.</p> 
<p>Ein weiteres Problem entsteht aber, wenn in der Datenquelle eine Menge
über ein Merkmal selektiert wird, das in der verknüpften Quelle nicht vorhanden ist.
Beispiel: Es werden die DAX-Werte aus dem Bestand selektiert. In der verknüpften Quelle,
z.B. Unternehmens-Ergebnisse, existieren diese Filter nicht. Dann könnte über 
einen Sonderfilter "WPKN aus Basis-Quelle" selektiert werden. Dieser Filter 
funktioniert aber nur, wenn die WPKN in auch tatsächlich enthalten ist. 
Folgende Konstruktion ist dann möglich (aber eben "kompliziert"):
<ul>
<li> In der Basis-Quelle:<ul> 
<li> Spalte WP-Name mit der Kombination aus WPKN und Namen in der Anzeige</li> 
<li> Zusätzlicher Text-Filter für WP-Name</li>
<li> Weitere Filter für die Selektion der Wertpapiere</li> 
</ul></li>
<li> In der verknüpften Quelle:<ul> 
<li> Spalte WPKN</li>
<li> Spalte WP-Name mit der WPKN zum Verknüpfen</li>  
<li> Sonderfilter "WPKN aus Basis-Quelle"</li> 
</ul></li>
<p>Dann würden die Anzeige der Spalte WP-Name und der Sonderfilter für die 
Verknüpfung ausreichen.</p>
<p>Aber auch hier hätte die einheitliche Verwendung von Dimensionen Vorteile:
In den Where-Klauseln könnte dann einheitlich die Konstruktion:<pre>
 wpkn in (select wpkn aus Dimension where [Selektion])
</pre>
verwendet werden.</p>
</ul>      