<?php 
/**
 * Stichtag erstellen, bei dem die Kundennummern einer Firma nicht hintereinander stehen.
 */

//pinfo() ;



$dbh = new PDO('mysql:host=localhost;dbname=vServer','wilfried','65Scholl');

function doSql($sql){
    global $dbh;
    $res = $dbh->exec($sql);
    if ($res === false){
        echo 'Fehler in SQL:'.$sql;
        echo "\n";
        echo $dbh->errorInfo()[2];
        die();
    }else{
        echo "Ausgeführt: ".$sql;
        echo "\n";
    }
}


 doSql('drop table if exists temp.kundennummern;');
 doSql('drop table if exists temp.firmen;');
 doSql('drop table if exists temp.neu;');
 doSql('drop table if exists temp.KundenStruktur;');
 
 doSql('update vServer.KundenStruktur set gueltig_bis = \'2025-12-31\' where gueltig_bis = \'9999-12-31\'
    and firma_geloescht_am is null and geloescht_am is null');
 doSql('delete from vServer.KundenStruktur where gueltig_ab=\'2026-01-01\'');
 

doSql('create table temp.kundennummern as select konzern_nr, firma_nr, konzern, firma, BetreuungsartSL, konzern_erfasst_am,
     firma_erfasst_am, konzern_geloescht_am, firma_geloescht_am, 
        kundennummer from vServer.KundenStruktur
where gueltig_bis = \'2025-12-31\' and firma_geloescht_am is null and geloescht_am is null
order by kundennummer;');

doSql('create table temp.firmen as select distinct konzern_nr, firma_nr, konzern, firma, BetreuungsartSL, konzern_erfasst_am,
     firma_erfasst_am, konzern_geloescht_am, firma_geloescht_am, count(*) as kunden from temp.kundennummern
GROUP by firma_nr;');

doSql('create table temp.KundenStruktur as SELECT * FROM vServer.KundenStruktur limit 0;');


 $stmtF = $dbh->query('select firma_nr,kunden from temp.firmen ');
 if ($stmtF === false){
     echo 'Fehler in SQL select firmen :';
     echo $dbh->errorInfo()[2];
     die();
 }

 $stmtK = $dbh->query('select kundennummer from temp.kundennummern order by kundennummer');
 if ($stmtF === false){
     echo 'Fehler in SQL select kundennummern :';
     echo $dbh->errorInfo()[2];
     die();
 }
 
 doSql('create table temp.neu (firma_nr CHAR(15) NOT NULL , kundennummer CHAR(15) NOT NULL ); ');
 
 doSql('create table temp.KundenStruktur as SELECT * FROM vServer.KundenStruktur limit 0;');

 $stmtIns = $dbh->prepare('insert into temp.neu set firma_nr = :firma_nr, kundennummer = :kundennummer');
 if ($stmtIns === false){
     echo 'Fehler bei prepare insert :';
     echo $dbh->errorInfo()[2];
     die();
 }
 
 $firmen = $stmtF->fetchAll(PDO::FETCH_ASSOC);
 
 $p = -1;
 $par = array();
 $nk = 1;
 while ($k = $stmtK->fetch(PDO::FETCH_ASSOC)){
    $par['kundennummer'] = $k['kundennummer'];
    $p ++;
    if ($p >= count($firmen)) {
        $p = 0;
        $nk++;
        echo "Firmen mit $nk Kundennummern\n";
    }
    while($firmen[$p]['kunden'] < 1){
        $p ++;
        if ($p >= count($firmen)){
            if ($p >= count($firmen)) {
                $p = 0;
                $nk++;
                echo "Firmen mit $nk Kundennummern\n";
            }            
        }
    }
    $par['firma_nr'] = $firmen[$p]['firma_nr'];
    $firmen[$p]['kunden'] --;
    if (false == $stmtIns->execute($par)){
        echo 'Fehler beim Insert: '.$stmtIns->errorInfo()[2];
    }
 }
 
  doSql('ALTER TABLE temp.neu ADD INDEX (firma_nr); ');


 $sql = <<<EOS
     insert into temp.KundenStruktur(
     `konzern_nr`, `firma_nr`, 
     `kundennummer`,
     `konzern`,
     `firma`,
     `kunde`,
     `BetreuungsartSL`,
     `gueltig_ab`,
     `gueltig_bis`,
     `konzern_erfasst_am`,
     `firma_erfasst_am`,
     `erfasst_am`,
     `konzern_geloescht_am`,
     `firma_geloescht_am`,
     `geloescht_am`)
    select 
     k1.`konzern_nr`, k1.`firma_nr`, 
     k2.`kundennummer`,
     k1.`konzern`,
     k1.`firma`,
     k2.`kunde`,
     k1.`BetreuungsartSL`,
     "2026-01-01",
     "9999-12-31",
     k1.`konzern_erfasst_am`,
     k1.`firma_erfasst_am`,
     k2.`erfasst_am`,
     k1.`konzern_geloescht_am`,
     k1.`firma_geloescht_am`,
     k2.`geloescht_am`
    from temp.firmen k1,
         vServer.KundenStruktur k2,
        temp.neu neu
    where  k2.gueltig_bis = '2025-12-31'
        and k1.firma_nr = neu.firma_nr
        and k2.kundennummer = neu.kundennummer;
 
 EOS;
 doSql($sql);
 
 $sql = <<<EOS
     insert into vServer.KundenStruktur(
     `konzern_nr`, `firma_nr`, 
     `kundennummer`,
     `konzern`,
     `firma`,
     `kunde`,
     `BetreuungsartSL`,
     `gueltig_ab`,
     `gueltig_bis`,
     `konzern_erfasst_am`,
     `firma_erfasst_am`,
     `erfasst_am`,
     `konzern_geloescht_am`,
     `firma_geloescht_am`,
     `geloescht_am`)
    select
     `konzern_nr`, `firma_nr`, 
     `kundennummer`,
     `konzern`,
     `firma`,
     `kunde`,
     `BetreuungsartSL`,
     `gueltig_ab`,
     `gueltig_bis`,
     `konzern_erfasst_am`,
     `firma_erfasst_am`,
     `erfasst_am`,
     `konzern_geloescht_am`,
     `firma_geloescht_am`,
     `geloescht_am`
        from temp.KundenStruktur;
EOS;
 doSql($sql);
 
 echo "FERTIG";
 

?>