<?php
/**
 * Projekt: WS-Reporter
 *          Erstellen einer Report-Definition
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.7.2022 ms
 *
 */
include 'includes/defender.inc';
if (isset($_REQUEST['program']) || (isset($_REQUEST['table']) && strpos($_REQUEST['table'], '?program='))
    || (isset($_REQUEST['report']) && (strpos($_REQUEST['report'], '?program') !== false))){
        header("Content-Type: text/plain; charset=UTF-8");
        http_response_code(425);
        echo "Veralteter Aufruf\n"; echo var_dump($_REQUEST);
        die();
}
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/wsrTranslate.inc';

// error_log(print_r($_REQUEST,true));

global $query, $wsReportVersion, $meldungen;
$meldung = "";


function setAddFilter(){
    global $query;
    if (array_key_exists("addFilter", $_REQUEST)){
        for ($i=0; $i < $_REQUEST['addFilter']; $i++){
            $fn = $_REQUEST['filter'.$i];
            $f = new RepFilter($fn);            
            if ($f != null){
                if ($query->repFilter->has($fn)){
                    $v = $query->repFilter->get($fn);
                    $f->abSpalte = $v->abSpalte;
                    $f->inTitelZeile = $v->inTitelZeile;
                    $f->selectorImOutput = $v->selectorImOutput;
                }
                if (array_key_exists('filterValue'.$i.'V1', $_REQUEST)){
                    $f->fs_von = $_REQUEST['filterValue'.$i.'V1'];
                }
                else $f->fs_von = null;
                if (array_key_exists('filterValue'.$i.'V2', $_REQUEST)){
                    $f->fs_bis = $_REQUEST['filterValue'.$i.'V2'];
                }
                else $f->fs_bis = null;
                if ($f->isSet())  $query->addFilter ->put($f);
            }
        }
    }    
}



if (session_status() == PHP_SESSION_NONE)  session_start();

anmeldungPruefen();
if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
    if ($query != null && !isValid($query->title)) $query->newReport();
//    else echo 'Use existing report<br>';
//    echo "VORHER: ";var_dump($query->addFilter);
}


if (isset($_REQUEST['get']) && isValid($_REQUEST['get'])){
    header("Content-Type: text/plain; charset=UTF-8");
    session_abort();
    if (file_exists('includes/erp'.$_REQUEST['get'].'.inc')) {
        if ($query != null){
            //FEHLER: Hier muss auch auf den Report geprüft werden
            if (array_key_exists('table', $_REQUEST)){
                $table = $_REQUEST['table'];
                if (strcmp($query->class_table,$table) !=0){
                    http_response_code(425);
                    echo WSRTranslate::translate('Es gibt nur einen aktiven Editor.')
                     . "\n".WSRTranslate::translate('Jetzt').': '.$query->class_table
                      ."\n".WSRTranslate::translate('Dieser Editor ist ungültig.');
                    die();
                }
            }
            if (array_key_exists('id', $_REQUEST)){
                if ($query->object_id != $_REQUEST['id']){
                    http_response_code(425);
                    echo WSRTranslate::translate('Es gibt nur einen aktiven Editor.')
                    . "\n".WSRTranslate::translate('Jetzt für Report').': '.$query->title
                    ."\n".WSRTranslate::translate('Dieser Editor ist ungültig.');
                    die();
                }
            }
            include './includes/erp'.$_REQUEST['get'].'.inc';
        }else{
            http_response_code (400);
            echo WSRTranslate::translate('Die Session ist abgelaufen.');
            die();
        }
    }else{
        http_response_code (400);
        echo WSRTranslate::translate('Ungültiger Aufruf').' '.$_REQUEST['get'];
        die();
    }
    die();
}

if (isset($_REQUEST['set']) && isValid($_REQUEST['set'])){
    header("Content-Type: text/plain; charset=UTF-8");
    if (file_exists('includes/ers'.$_REQUEST['set'].'.inc')) {
        if ($query != null){
            if (array_key_exists('table', $_REQUEST)){
                $table = $_REQUEST['table'];
                if (strcmp($query->class_table,$table) !=0){
                    http_response_code(425);
                    echo WSRTranslate::translate('Es gibt nur einen aktiven Editor.')
                    . "\n".WSRTranslate::translate('Jetzt').': '.$query->class_table
                    ."\n".WSRTranslate::translate('Dieser Editor ist ungültig.');
                    die();
                }
            }
            if (array_key_exists('id', $_REQUEST)){
                if ($query->object_id != $_REQUEST['id']){
                    http_response_code(425);
                    echo WSRTranslate::translate('Es gibt nur einen aktiven Editor.')
                    . "\n".WSRTranslate::translate('Jetzt für Report').': '.$query->title
                    ."\n".WSRTranslate::translate('Dieser Editor ist ungültig.');
                    die();
                }
            }
            include './includes/ers'.$_REQUEST['set'].'.inc';
        }else{
            http_response_code (400);
            echo WSRTranslate::translate('Die Session ist abgelaufen.');
            die();
        }
    }else{
        http_response_code (400);
        echo WSRTranslate::translate('Ungültiger Aufruf').' '.$_REQUEST['set'];
        die();
    }
    
    session_write_close();
    die();
}


if ($query != null) setAddFilter();


$table = null;


$meldungen = '';
if (isset($_REQUEST['import'])){    
    require './includes/importReportDef.inc';
    $importFileName = $_FILES['importFile']['name'];
    $datei = fopen($_FILES['importFile']['tmp_name'],'r');
    importReportDef($datei);
    fclose($datei);
    if ($query == null){
        header("Content-Type: text/plain; charset=UTF-8");
        header("Content-Disposition: attachment; filename=\"Fehlerbericht.txt\"");
        echo $meldungen;
        die();
    }
    
    
    $_SESSION['WSReportQuery'] = $query;
    session_write_close();
    $table = $query->class_table;
    if (isValid($meldungen)) $meldung = $meldungen;
    else $meldung = WSRTranslate::translate("Report neu importiert.");
}else{
    if (array_key_exists('table', $_REQUEST)){
        $table = $_REQUEST['table'];
    }
    if (array_key_exists('reportID', $_REQUEST)  && $_REQUEST['reportID'] > 0){
        if ( ($query == null)
            || $query->reportID != $_REQUEST['reportID']
            || (array_key_exists('action', $_REQUEST) && $_REQUEST['action'] == 'reload')
            ){                
                require_once './includes/loadReportDef.inc';
                if (loadReportID($_REQUEST['reportID'])){
                    if (isValid($meldungen)) $meldung = $meldungen;
                    else $meldung = WSRTranslate::translate("Report neu eingelesen.");
                    $_SESSION['WSReportQuery'] = $query;
                    // initialisieren
                    if ($query != null) setAddFilter();
                    session_write_close();
                }else  if ($table != null && isValid($table)){
                    $query = new Query($table);
                    require_once './includes/loadClassDef.inc';                    
                    loadClassDef($query);
                    $query->newReport();
                    $meldung = WSRTranslate::translate("Neuer Report für Datenquelle")." ".$query->class_table;
                    if (isValid($meldungen)) $meldung .= '<br>'.$meldungen;
                    $_SESSION['WSReportQuery'] = $query;
                    session_write_close();
                }
        }
    }
    else
        if (array_key_exists('report', $_REQUEST)  && isValid($_REQUEST['report'])){
            if ( ($query == null)
                || !isValid($query->title)
                || strcmp($_REQUEST['report'], $query->title) != 0
                || (array_key_exists('action', $_REQUEST) && $_REQUEST['action'] == 'reload')
                ){
                    require_once './includes/loadReportDef.inc';
                    if (loadReport($_REQUEST['report'])){
                        if (isValid($meldungen)) $meldung = $meldungen;
                        else $meldung = "Report neu eingelesen.";
                        $_SESSION['WSReportQuery'] = $query;
                        // initialisieren
                        if ($query != null) setAddFilter();
                        session_write_close();
                    }else  if ($table != null && isValid($table)){
                        $query = new Query($table);
                        require_once './includes/loadClassDef.inc';
                        loadClassDef($query);
                        $query->newReport();
                        $meldung = WSRTranslate::translate("Neuer Report für Datenquelle")." ".$query->class_table;
                        if (isValid($meldungen)) $meldung .= '<br>'.$meldungen;
                        $_SESSION['WSReportQuery'] = $query;
                        session_write_close();
                    }
            }
    }
    else
        if ($table != null && ($query == null
            || (array_key_exists('reload',$_REQUEST) && isValid($_REQUEST['reload']))
            || (array_key_exists('reload',$_REQUEST) && isValid($_REQUEST['start']))
            || strcmp($table, $query->class_table) != 0)){
                $query = new Query($table);
                require_once './includes/loadClassDef.inc';
                loadClassDef($query);
                $meldung = WSRTranslate::translate("Neuer Report für Datenquelle")." ".$query->class_table;
                if (isValid($meldungen)) $meldung .= '<br>'.$meldungen;
                
                $_SESSION['WSReportQuery'] = $query;
                // initialisieren
                if (!isValid($query->title)) $query->newReport();
                session_write_close();
    } else
            session_abort();
}
if ($query->addQueries != null)
    $joins = $query->addQueries->size() > 0;
?>

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title><?=$query->outputTitlePrefix.': '.WSRTranslate::translate('Report-Anforderung')?></title>
<meta name="GENERATOR" content="WS-PHP: editReport.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="<?=$query->reportCSS ?>" >
<script type="text/javascript" src="./jscss/tableHeader.js">
	</script>
<script type="text/javascript">
var call = "<?=$_SERVER['SCRIPT_NAME']?>?id=<?=$query->object_id?>&table=<?=$query->class_table?>";
var requestID = "<?=$query->object_id?>";
var requestTable = "<?=$query->class_table?>";
console.log("Call="+call);
	</script>
	
<script type="text/javascript" src="./jscss/WSReport.js">
	</script>
<script type="text/javascript" >
window.addEventListener('load', function() {
<?php
if (isset($_REQUEST['import'])){
    global $importFileName;
?>
alert("<?=WSRTranslate::translate('Neuer Report').' '.$query->title."\n"
     .WSRTranslate::translate('wurde aus Datei').' '.$importFileName.' '.WSRTranslate::translate('importiert')
         .".\n".WSRTranslate::translate('ACHTUNG').': '
         . WSRTranslate::translate('Die Report-Definition wurde noch NICHT gespeichert!')
         ."\n".WSRTranslate::translate("Sie muss hier zuerst geprüft werden.")?>");

<?php }
if ($_SERVER["HTTP_HOST"] == "localhost:8898"){
    ?>
    var body = document.getElementsByTagName('body')[0];
    body.className = "entwicklung";
	
<?php 
}
if (array_key_exists('action', $_REQUEST) && $_REQUEST['action'] == 'start'){
?>
showHide('XReports');	
<?php }else{
?>
showHide('Alle');	
<?php 
}
?> 	
 });
</script>
</head>
<body>
<h1><?=WSRTranslate::translate('Report-Anforderung')?></h1>
<h2 <?=makeTitleClass($query->table_description,'') ?>><?=$query->outputTitlePrefix?></h2>

<div id="Meldung" title="<?=WSRTranslate::translate('zum Löschen doppelt klicken')?>" ondblclick="clearMeldung()"><?=$meldung ?></div>

<div class="editorBox" id="XSpezFilterList">
<div class="xButton" onclick="filterList('close')" title="schließen">&otimes;</div>
<h3 class="help nowrap" title=
"<?=WSRTranslate::translate('Liste der auswählbaren Werte')?>"><?=WSRTranslate::translate('Filter-Liste')?></h3>
<div id="SpezFilterList">
</div>
</div>

<div class="inlineBox centerBox">
<?php 
if (array_key_exists('Name', $_SESSION))
    echo '<b>Anmeldung:</b> '.$_SESSION['Name']."\n";
?>
<h3><?=WSRTranslate::translate('Globale Eigenschaften')?> <?=anleitung('2','rdTitle') ?></h3>
<div id="SpezTitle">
<?php 
include './includes/erpTitle.inc';
?>
</div>
</div>
<div class="inlineBox" id="XQuellenDesc"><h3><?=WSRTranslate::translate('Beschreibung der Quellen')?></h3>
<div id="QuellenDesc">
</div>
</div>

<div class="inlineBox" id="XSpezZeilen"><h3><?=WSRTranslate::translate('Zeilenaufbau')?><?=anleitung('2','rdZeilen') ?></h3>
<div id="SpezZeilen">
<?php 
include './includes/erpZeilen.inc';
?>
</div>
</div>
<div class="inlineBox" id="XSpezWerte"><h3><?=WSRTranslate::translate('Werte')?><?=anleitung('2','rdWerte') ?></h3>
<div id="SpezWerte">
<?php 
include './includes/erpWerte.inc';
?></div>
</div>
<div class="inlineBox" id="XSpezSpalten"><h3><?=WSRTranslate::translate('Spalten')?><?=anleitung('2','rdSpalten') ?></h3>
<div id="SpezSpalten">
<?php 
include './includes/erpSpalten.inc';
?>
</div>
</div>

<div class="inlineBox" id="XSpezFilter"><h3 class="help" title=
"<?=WSRTranslate::translate('Leere Filter für die Basisquelle können beim Aufruf über Parameter
gesetzt werden. Filter aus den Aufrufparametern, zu denen in der
Report-Anforderung kein Filter existiert, werden ignoriert. Eine
Filter-Option in der Datenquelle reicht nicht aus.')?>

<?=WSRTranslate::translate('Sonderbehandlung der Filter bei verknüpften Tabellen:
Grundsätzlich werden die Filter aus der Basistabelle übernommen, 
wenn ein gleichnamiger Filter in der Datenquelle existiert, und in der
Report-Anforderung für das verknüpfte Objekt KEIN gleichnamiger Filter gesetzt ist.')?>
<?=WSRTranslate::translate('Der Filter kann auch leer sein. Explizit gesetzte Filter werden nicht überschrieben.')?>

<?=WSRTranslate::translate('Ein explizit gesetzter oder leerer Filter für eine verknüpfte Datenquelle verhindert 
auch die Zuordnung zu einer gleichnamigen Zeile oder Spalte beim Join. Der so selektierte Wert 
wird dann in allen Zeilen / Spalten der Tabelle einheitlich verwendet')?>."><?=WSRTranslate::translate('Filter')?><?=anleitung('2','rdFilter') ?></h3>
<div id="SpezFilter">
<?php 
include './includes/erpFilter.inc';
?>
</div>
</div>

<div class="inlineBox" id="XSpezAddFilter"><h3 class="help" title=
"<?=WSRTranslate::translate('Hier können zusätzliche Filter zum Testen gesetzt werden, die nicht zur 
Report-Defintion gehören, sondern nur beim aktuellen Ausführen benutzt werden.
Es können nur Filter gesetzt werden, die bereits als leere (nicht gesetzte) Filter
in der Filter-Liste stehen.
')?>"><?=WSRTranslate::translate('Zusatz-Filter')?></h3>
<div id="SpezAddFilter">
<?php 
include './includes/erpAddFilter.inc';
?>
</div>
</div>

<?php 
  $showHist = $query->histType > 0;
  foreach($query->dimensions as $nr => $dim){
      if (false) $dim = new Dimension(null);
      if ($dim->histType > 0){
          if ( $query->reportHasDim('base', $nr)) $showHist = true;
      }
  }
  for ($i = 0; $i < $query->repTables->size() && ! $showHist; $i ++){
      $rtab = $query->repTables->getPos($i);
      $rquery = $rtab->query;
      if ($rQuery->histType > 0 ) $showHist = true;
      else {
          foreach($rquery->dimensions as $nr => $dim){
              if (false) $dim = new Dimension(null);
              if ($dim->histType > 0){
                  if ( $query->reportHasDim($rtab->kennzeichen, $nr)) $showHist = true;
              }
          }
      }
  }
      
  if ($showHist){
?>
<div class="inlineBox" id="XSpezHist"><h3><?=WSRTranslate::translate('Ermittlung der Stichtage für Gültigkeit')?><?=anleitung('2','rdHist') ?></h3>
<div id="SpezHist">
<?php 
include './includes/erpHist.inc';
?>
</div>
</div>


<?php  } ?>




<?php 
  if ($joins){
?>
<br id="Xbr">
<div class="inlineBox" id="XSpezJoinVrz"><h3><?=WSRTranslate::translate('Zusätzliche Datenquellen')?><?=anleitung('2','rdJoins') ?></h3>
<div id="SpezJoinVrz">
<?php 
include './includes/erpJoinVrz.inc';
?>
</div>
</div>

<div class="inlineBox" id="XSpezJoins"><h3><?=WSRTranslate::translate('Verknüpfte Datenquellen')?></h3>
<div id="SpezJoins">
<?php 
include './includes/erpJoins.inc';
?>
</div>
</div>

<?php  } ?>

<div class="inlineBox centerBox"  id="XReportVerweise"><h3><?=WSRTranslate::translate('Verweise auf weitere Reports')?><?=anleitung('2','rdRepLinks') ?></h3>
<div class="small"><?=WSRTranslate::translate('Hier können weitere Verweise auf Reports in die Ausgabe aufgenommen werden')?>
</div>

<div id="SpezReportVerweise" >
<?php 
include './includes/erpReportVerweise.inc';
?>  
</div>
</div>




<div class="inlineBox centerBox"  id="XReports"><h3><?=WSRTranslate::translate('Gespeicherte Report-Anforderungen').anleitung('2','rdReports') ?></h3>
<div class="small"><?=WSRTranslate::translate('Die Report-Anforderung wird unter Ihrer Überschrift gespeichrt. D.h. bei gleichen
Überschriften wird die alte Anforderung überschrieben.')?><br>
<?=WSRTranslate::translate('Ein Klick auf die Überschrift führt die Anforderung aus und zeigt den Report an.
Mit dem Button kann die Report-Anforderung in diesen Editor geladen und bearbeitet werden.')?>
</div>

<div id="SpezReports" class="noprint">
<?php 
include './includes/erpReports.inc';
$dqAdminRechte = dqAdminRechte();
?>  
</div>
</div>
<form method="POST" action="<?=$_SERVER['SCRIPT_NAME']?>" target="ReportOutput"
    id = "ReportForm">
    <input type="hidden" value="<?=$query->class_table?>" name="table" />
    <input type="hidden" value="<?=$query->title?>" name="report" />
    <input type="hidden" value="<?=$query->reportID?>" name="reportID" />
    <input type="hidden" value="<?=$query->object_id?>" name="id" />
    <input type="hidden" value="" name="action" />
    <input type="hidden" value="" name="set" />    
    </form>
<footer class="leiste" id="footLong">
<div>&nbsp;</div><br>
<div class="Fleft " onclick="hideFoot()">
<span class="clickFlaeche">&lt;&lt;</span></div>
<div class="Fcenter nowrap">
    <input type="button" name = "run" value="<?=WSRTranslate::translate('Ausgabe erzeugen')?>" onclick="outputReport()"/>
<?php 
if ($dqAdminRechte){
?>
    <input type="button" name = "save1" id= "saveStd" value="<?=WSRTranslate::translate('Anforderung speichern')?>" onclick="saveReport(false,false);"/>
    <?php
}
    $canProd = false; //isValid($query->prodDatabase);
    if ($canProd){
        ?>
        <input type="button" name = "save2" id= "saveProd" value="<?=WSRTranslate::translate('Anf. produktiv setzen')?>" onclick="saveReport(false,true);"/>
        <?php
    }
    ?>
    <input type="button" class= "hidden confirm" name = "save3" id= "saveCStd" value="<?=WSRTranslate::translate('speichern bestätigen')?>" onclick="saveReport(true,false);"/>
    <?php
    if ($canProd){
        ?>
        <input type="button" class= "hidden confirm" name = "save4" id= "saveCProd" value="<?=WSRTranslate::translate('produktiv setzen bestätigen')?>" onclick="saveReport(true,true);"/>
        <?php
    }

    // Hinweis: die Befehle werden in WSReport.js in HTTP-Requests umgesetzt
    ?>
    <input type="button" class= "hidden" name = "abort" id= "saveAbort" value="<?=WSRTranslate::translate('abbrechen')?>" onclick="saveAbort();"/>
    <select id="befehl"  title="<?=WSRTranslate::translate('Weitere Aktionen')?>">
    <option value="aktualisieren"><?=WSRTranslate::translate('aktualisieren')?></option>
    <option value="dokumentieren" selected><?=WSRTranslate::translate('dokumentieren')?></option>
<?php 
    if (($_SESSION['globalAdmin'] || $_SESSION['uebersetzer'])  
//    && $query->rLanguage == substr($_SESSION['Sprache'], 0,2)
        ){    
?>
    <option value="übersetzen"><?=WSRTranslate::translate('übersetzen')?></option>
<?php 
    }
?>    
<?php 
if ($dqAdminRechte){
?>   
    <option value="showSQL"><?=WSRTranslate::translate('SQL anzeigen')?></option>
    <option value="getLink"><?=WSRTranslate::translate('GET-Link erzeugen')?></option>
<?php 
}
?>
    <option value="neuerReport"><?=WSRTranslate::translate('neuer Report')?></option>
<?php 
if ($dqAdminRechte && $query->reportID > 0){
?>   
    <option disabled='true'  id='newReportOption' value="alsNeuerReport"><?=WSRTranslate::translate('als neuen Report anlegen')?></option>
<?php 
}
?>
<?php 
if ($_SESSION['globalAdmin']){
?> 
   <option value="editQuery"><?=WSRTranslate::translate('Datenquelle bearbeiten')?></option>
<?php 
}
?>    
    <option value="freigeben"><?=WSRTranslate::translate('freigeben')?></option>
    <option value="exportieren"><?=WSRTranslate::translate('exportieren')?></option>
    </select>
    <input type="button" id= "befehlAusführen" value="<?=WSRTranslate::translate('ausführen')?>" onclick="befehlAusführen()"/>
    <input type="button" id= "Anleitung" value="<?=WSRTranslate::translate('Anleitung')?>" onclick="anleitung('12','reports')"/>
</div>
<br>
<div class="Fleft"><?=WSRTranslate::translate('WS Reporter Version')?> <?=$wsReportVersion?></div>
<div class="Fright right">&copy; WS Unternehmensberatung</div>
</footer>
<footer  id="footShort" class="hidden" width="min-content" title="<?=WSRTranslate::translate('Fu&szlig;zeile mit Buttons wieder anzeigen')?>">
<div onclick="showFoot()"  ><span class="clickFlaeche">&gt;&gt;</span></div>
</footer>
</body>
</html>