<?php 
/**
 * Projekt: WS-Reporter
 *          Benutzer an- und abmelden
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    12.8.2022 NLS
 *
 */


if (session_status() == PHP_SESSION_NONE)  session_start();
require_once './phpsec/createDBH.inc';
require_once './includes/qTranslate.inc';
require_once './includes/wsrTranslate.inc';
if (array_key_exists('user', $_REQUEST)) $user = $_REQUEST['user'];
else $user = '';
$stmt = $dbh->prepare('select * from wsrUser where binary user = :user and binary password=:pass');
$password = '';
if (array_key_exists('pass', $_REQUEST)) $password = $_REQUEST['pass'];
$stmt->execute(array('user'=>$user, 'pass' => $password));
if ($erg = $stmt->fetchObject()){
    // Berechtigung aufbauen
    if (isset($_SESSION['Rechte'])) unset($_SESSION['Rechte']);
    if (isset($_SESSION['RechteG'])) unset($_SESSION['RechteG']);
    if (isset($_SESSION['EndUser'])) unset($_SESSION['EndUser']);
    if (isset($_SESSION['reports'])) unset($_SESSION['reports']);
    if (isset($_SESSION['WSReportQuery'])) unset($_SESSION['WSReportQuery']);
    
    $_SESSION['User'] = $user;
    $_SESSION['Name'] = $erg->userLongName;
    $_SESSION['Sprache'] = $erg->uLanguage;
    $_SESSION['uebersetzer'] = false;

    if (array_key_exists('uLanguage', $_REQUEST)) $_SESSION['Sprache'] = $_REQUEST['uLanguage'];
    if (!isValid($_SESSION['Sprache'])) $_SESSION['Sprache'] = 'de';
    
    if ($erg->adminRecht)  {
        $_SESSION['globalAdmin'] = true;
        $_SESSION['uebersetzer'] = true;
    }
    else {
        $_SESSION['globalAdmin'] = false;
        if ($erg->wsrUebersetzer) $_SESSION['uebersetzer'] = true;
        if ($erg->endUser) $_SESSION['EndUser'] = true;
        $rTable = array();
        if (isValid($erg->qAddFilter)){
            $rTable['filter'] = trim($erg->qAddFilter);
            $rTable['filterVon'] = trim($erg->qAddFilterVon);
            $rTable['filterBis'] = trim($erg->qAddFilterBis);
        }
        if (isValid($erg->qAddFilter2)){
            $rTable['filter2'] = trim($erg->qAddFilter2);
            $rTable['filter2Von'] = trim($erg->qAddFilter2Von);
            $rTable['filter2Bis'] = trim($erg->qAddFilter2Bis);
        }
        $_SESSION['RechteG'] = $rTable;
        
        $stmt->closeCursor();
        $stmt = $dbh->prepare('select * from wsrRechte where binary user = :user');
        $stmt->execute(array('user'=>$user));
        $rechte = array();
        while ($erg2 = $stmt->fetchObject()) {
            $rTable = array();
            $rTable['admin'] = $erg2->adminRecht;
            if (isValid($erg2->qAddFilter)){
                $rTable['filter'] = trim($erg2->qAddFilter);
                $rTable['filterVon'] = trim($erg2->qAddFilterVon);
                $rTable['filterBis'] = trim($erg2->qAddFilterBis);
            }
            if (isValid($erg2->qAddFilter2)){
                $rTable['filter2'] = trim($erg2->qAddFilter2);
                $rTable['filter2Von'] = trim($erg2->qAddFilter2Von);
                $rTable['filter2Bis'] = trim($erg2->qAddFilter2Bis);
            }
            $rechte[$erg2->table_name] = $rTable;
        }
        
        $_SESSION['Rechte'] = $rechte;
        //            error_log("Anmeldung $user: mit den Rechten\n".print_r($rechte,true));
    }
    $stmt->closeCursor();
    // Standard-Report-Liste aufbauen
    $stmtR = $dbh->query('select reportTitle from wsrReports '
        .' where rolle = "'.$erg->rolle.'" order by SortNr');
    $reports = array();
    if ($erg->reportTitle != null && $erg->reportTitle != '') {
        $reports[] =  qTranslate::translateReportTitle($erg->reportTitle);
    }
    while ($zR = $stmtR->fetchObject()){
        if ($zR->reportTitle != $erg->reportTitle) $reports[] = qTranslate::translateReportTitle($zR->reportTitle);
    }
    $stmtR->closeCursor();
    $_SESSION['reports'] = $reports;
    
    
}else{
    $stmt->closeCursor();
    //$stmt = $dbh->prepare('insert into wsrUser set password=:pass, userLongName = :longName, adminRecht = :admin, error_count = 0, user = :user');
    $meldung = WSRTranslate::translate('Ungültige Anmeldung').': ';
    
    if (array_key_exists('User', $_SESSION)) {
        $meldung .= $_REQUEST['user'];
        unset($_SESSION['User']);
    }
    unset($_SESSION['Rechte']);
    unset($_SESSION['RechteG']);
    unset($_SESSION['reports']);
    $_SESSION['globalAdmin'] = false;
    unset($user);
}
session_write_close();


?>