<?php
/**
 * Projekt: WS-Reporter
 *          Filter-Optionen bearbeiten bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.02.2023 MS
 *
 */
require_once './includes/wsrTranslate.inc';
global $query;

if (!isValid($query->qEditVar)){
    http_response_code(425);
    echo "Ungültiger Aufruf qEditVar = $query->qEditVar\n";
    echo var_dump($_REQUEST);
    return;
}
$wo = $query->qEditSubject;
$column_name = $query->qEditVar;
$mr = $query->metaData[$column_name];
if ($mr == null){
    http_response_code(425);
    echo WSRTranslate::translate("Ungültiger Aufruf keine Metadaten für")." qEditVar = $query->qEditVar\n";
    echo var_dump($_REQUEST);
    return;
}
    $selectOptions = null;
    if ($mr != null) {
        $selectOptions = $mr->getSelectOptions();
    }
    else echo "<b>Metadaten zu $column_name nicht gefunden!!!</b><br>";
    if ($selectOptions == null) $selectOptions = array()
    
    ?>
<div class="xButton" onclick="closeSelectOptions()" title="<?=WSRTranslate::translate('schließen OHNE speichern')?>">&otimes;</div>
<h3><?=WSRTranslate::translateH('Auswahl-Optionen für')?> <?=$column_name?></h3>
<form id="selectOptions" onsubmit="return false;">
<table id="selectOptionsTable">
<thead>
<?php
if ($mr->filterType == MetaRecord::HISTDEL){
    ?>
	<tr><th><?=WSRTranslate::translate('Filter')?></th>
	<th><?=WSRTranslate::translate('Anzeige')?></th></tr>
	<?php	
}elseif ($mr->filterType == MetaRecord::SONDERFILTERSEL){
	?>
	<tr><th><?=WSRTranslate::translate('Filter')?></th><td>
	<th><?=WSRTranslate::translate('Filter-Code')?></th>
	<th colspan="2"><?=WSRTranslate::translate('Bewegen')?></th>
	<th><?=WSRTranslate::translate('löschen')?></th></tr>
	<?php	
}else{
?>
<tr><th><?=WSRTranslate::translate('Wert')?></th>
<th><?=WSRTranslate::translate('Anzeige')?></th>
<th colspan="2"><?=WSRTranslate::translate('Bewegen')?></th>
<th><?=WSRTranslate::translate('löschen')?></th></tr>
<?php
} ?>
</thead>
<tbody>
<?php
$i = 0;
	if ($selectOptions != null)
		for ($i = 0; $i < count($selectOptions); $i++){
//			System.out.println(selectOptions[i][0]+":"+selectOptions[i][1]);        
if ($mr->filterType == MetaRecord::HISTDEL){
?>
	<tr>
	<input name="SOZW" type="hidden" value="<?=$selectOptions[$i][0]?>" />
	<th class="left"><?=HistoryOptions::getKlartext($selectOptions[$i][0]) ?></th>
	<td><input name="SOZL" value="<?=quoteForText(blankAsNull($selectOptions[$i][1])) ?>" size="30" autocomplete="off" /></td></tr>
	<?php	
}else { 
?>

<tr><td><input name="SOZW" value="<?=quoteForText(blankAsNull($selectOptions[$i][0])) ?>" size="15" autocomplete="off" /></td>
<?php 
if ($mr->filterType == MetaRecord::SONDERFILTERSEL){
    if (strlen($selectOptions[$i][1]) < 80){
    ?>
<td>
<textarea name="SOZL" rows="2" cols="40" autocomplete="off" 
  ><?=quoteForText(blankAsNull($selectOptions[$i][1])) ?></textarea> 	 
<?php 
}else{
    ?>
<td>
<textarea name="SOZL" rows="5" cols="60" autocomplete="off" 
  ><?=quoteForText(blankAsNull($selectOptions[$i][1])) ?></textarea> 	 
<?php 
}
}else{
    ?>
<td><input name="SOZL" value="<?=quoteForText(blankAsNull($selectOptions[$i][1])) ?>" size="30" autocomplete="off" /></td>
<?php 
}
?>
<td onclick="selOptUp(this)" class="center" name="auf"><?=iconUp() ?></td>
<td onclick="selOptDown(this)" class="center" name="ab"><?=iconDown() ?></td>
<td onclick="delSelRow(this)" class="center" name="del"><?=iconDelete() ?></td>
</tr>
<?php
		}
	}// Schleife
?>
</tbody>
<?php if ($mr->filterType != MetaRecord::HISTDEL){
    ?>
<tfoot>
<tr><td><input name="SOZW" id="selOptionsNew" value="" size="15" onchange="newSelRow(this)" autocomplete="off"/></td>
<td colspan="4" class="center"> <?=WSRTranslate::translate('(neu eintragen)')?> </td>
</tr>
</tfoot>
<?php } ?>
</table>
</form>
<div class="center">
<button onclick="setSelectOptions()"><?=WSRTranslate::translate('speichern')?></button>	 
<button onclick="closeSelectOptions()"><?=WSRTranslate::translate('abbrechen')?></button>	 

<?php if ($mr->filterType != MetaRecord::HISTDEL){
    ?>
<button onclick="clearSelectOptions()"><?=WSRTranslate::translate('löschen')?></button>	 
<button onclick="readSelectOptions('value')"><?=WSRTranslate::translate('einlesen')?></button>	 
<button onclick="readSelectOptions('label')"><?=WSRTranslate::translate('einlesen nach Anzeige')?></button>
<?php } ?>	 
</div><br><br><br>
	
 
