<?php
/**
 * Projekt: WS-Reporter
 *          Filter-Optionen bearbeiten bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.2.2023 MS
 *
 */

$mr = $query->metaData['WSR_WERTELISTE'];
if ($mr == null){
    http_response_code(425);
    echo "<?=WSRTranslate::translate('Ungültiger Aufruf keine Metadaten für WSR_WERTELISTE')?>\n";
    echo var_dump($_REQUEST);
    return;
}
    $selectOptions = null;
    if ($mr != null) {
        $selectOptions = $mr->getSelectOptions();
    }
    else echo "<b><?=WSRTranslate::translate('Metadaten zur Werte-Liste nicht gefunden')?>!!!</b><br>";
    if ($selectOptions == null) $selectOptions = array()
    
    ?>
<div class="xButton" onclick="closeValueList()" title="<?=WSRTranslate::translate('schließen OHNE speichern')?>">&otimes;</div>
<h3 class='help' title=
"<?=WSRTranslate::translate('Der Report wird auf der Basis einer Werte-Gruppe aufgebaut.
Für die Ausgabe kann dann diese Werte-Gruppe
durch jede andere ersetzt werden.
&quot;Intern&quot; ist der Teil der internen Werte-Namen,
der ersetzt wird. Die Anzeige ist für den Benutzer.')?>"><?=WSRTranslate::translateH('Liste der zu ersetzenden Werte')?></h3>
<form id="selectOptions" onsubmit="return false;">
<table id="selectOptionsTable">
<thead>
<tr><th><?=WSRTranslate::translateH('Intern')?></th><th><?=WSRTranslate::translateH('Anzeige')?></th>
<th colspan="2"><?=WSRTranslate::translateH('Bewegen')?></th><th><?=WSRTranslate::translateH('löschen')?></th></tr>
</thead>
<tbody>
<?php
$i = 0;
	if ($selectOptions != null)
		for ($i = 0; $i < count($selectOptions); $i++){
//			System.out.println(selectOptions[i][0]+":"+selectOptions[i][1]);        
?>
<tr><td><input name="SOZW" value="<?=quoteForText(blankAsNull($selectOptions[$i][0])) ?>" size="40" autocomplete="off" /></td>
<td><input name="SOZL" value="<?=quoteForText(blankAsNull($selectOptions[$i][1])) ?>" size="40" autocomplete="off" /></td>
<td onclick="selOptUp(this)" class="center" name="auf"><?=iconUp() ?></td>
<td onclick="selOptDown(this)" class="center" name="ab"><?=iconDown() ?></td>
<td onclick="delSelRow(this)" class="center" name="del"><?=iconDelete() ?></td>
</tr>
<?php
		
	}// Schleife
?>
</tbody>
<?php if ($mr->filterType != MetaRecord::HISTDEL){
    ?>
<tfoot>
<tr><td><input name="SOZW" id="selOptionsNew" value="" size="40" onchange="newSelRow(this)" autocomplete="off"/></td>
<td colspan="4" class="center"> (<?=WSRTranslate::translateH('neu eintragen')?>) </td>
</tr>
</tfoot>
<?php } ?>
</table>
</form>
<div class="center">
<button onclick="setValueList()"><?=WSRTranslate::translate('speichern')?></button>	 
<button onclick="closeValueList()"><?=WSRTranslate::translate('abbrechen')?></button>	 
<button onclick="clearValueList()"><?=WSRTranslate::translate('löschen')?></button>	 
</div><br><br><br>
	
 
