<?php
/**
 * Projekt: WS-Reporter
 *          Aktionen bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 */

if (strcmp($_REQUEST['action'],"saveClass") == 0){
    require './includes/saveClassDef.inc';
    return;
}

if (strcmp($_REQUEST['action'],"selectDimension") == 0){    
    require_once './includes/classes.inc';
    $query->selectedDimension = $_REQUEST['selectDimension'];
    return;
}

if (strcmp($_REQUEST['action'],"deleteClass") == 0){
    require_once './phpsec/createDBH.inc';
    $sql = new SqlAbfrage('WSR');
    $sql->sql = "delete from queryAttribute";
    $sql->addSel('table_name =', $query->class_table);
    if (false === $sql->execute()){
        echo 'Fehler bei delete from queryAttribute';
        die();
    }
    

    $sql = new SqlAbfrage('WSR');
    $sql->sql = "delete from queryColumnMetadata";
    $sql->addSel('table_name =', $query->class_table);
    if (false === $sql->execute()){
        echo 'Fehler bei delete from queryColumnMetadata';
        die();
    }
    
    $sql = new SqlAbfrage('WSR');
    $sql->sql = "delete from queryColumnMetadataSelectOptions";
    $sql->addSel('table_name =', $query->class_table);
    if (false === $sql->execute()){
        echo 'Fehler bei delete from queryColumnMetadataSelectOptions';
        die();
    }
    
    $sql = new SqlAbfrage('WSR');
    $sql->sql = "delete from queryDimensions";
    $sql->addSel('table_name =', $query->class_table);
    if (false === $sql->execute()){
        echo 'Fehler bei delete from queryColumnMetadata';
        die();
    }
    $sql = new SqlAbfrage('WSR');
    $sql->sql = "delete from wsrAdminQuery";
    $sql->addSel('table_name =', $query->class_table);
    if (false === $sql->execute()){
        echo 'Fehler bei delete from wsrAdminQuery';
        die();
    }
    echo $query->class_table.' wurde gelöscht.';
    return;
}

if ($_REQUEST['action'] == "updateDimHist"){
    require_once './includes/classes.inc';
    require_once './includes/loadClassDef.inc';
    $dim = $query->dimensions[$query->selectedDimension];
    if (false) $dim = new Dimension('N');
    $dimQuery = new Query($dim->dimName);
    loadSimpleClassDef($dimQuery);
    $dim->histType = $dimQuery->histType;
    $dim->historyOption = $dimQuery->historyOption;
    if (isValid($dimQuery->histAb)){
        $sv = $dimQuery->getReportMetaRecord($dimQuery->histAb)->getSelectVar();
        if (strpos($sv, 'dim.') === false) $sv = 'd'.$dim->dimNr.'.'. $sv;
        else $sv = str_replace('dim.', 'd'.$dim->dimNr.'.', $sv);
        $dim->histAbSelect = $sv;
    }else $dim->histAbSelect = null;
    
    if (isValid($dimQuery->histBis)){
        $sv = $dimQuery->getReportMetaRecord($dimQuery->histBis)->getSelectVar();
        if (strpos($sv, 'dim.') === false) $sv = 'd'.$dim->dimNr.'.'. $sv;
        else $sv = str_replace('dim.', 'd'.$dim->dimNr.'.', $sv);
        $dim->histBisSelect = $sv;
    } else $dim->histBisSelect = null;
    if (isValid($dimQuery->histStichtag)){
        $sv = $dimQuery->getReportMetaRecord($dimQuery->histStichtag)->getSelectVar();
        if (strpos($sv, 'dim.') === false) $sv = 'd'.$dim->dimNr.'.'. $sv;
        else $sv = str_replace('dim.', 'd'.$dim->dimNr.'.', $sv);
        $dim->histStichtagSelect = $sv;
    } else $dim->histStichtagSelect = null;
    return;
}


http_response_code(425);
echo 'Unbekannter Aufruf '.$_REQUEST['action'];
return;

    