<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der Zusatz-Filter im Report-Editor
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.6.2022 ms
 *
 */
global $query;
require_once './includes/enterFilterSpec.inc';

    $qFilter = $query->addFilter;
    if ($qFilter != null){
        for ($i = 0; $i < $qFilter->size(); $i++){
            $filter = $qFilter->getPos($i);
            if ($filter == null) {
                error_log("Leerer Add-Filter an Position $i");
                continue;
            }
            $rt = null;
            $pref = '';
            $star = '';
            if (substr($filter->getName(),1,1)== ':'){
                $rt = $query->repTables->get(substr($filter->getName(),0,1));
                if ($rt != null){
                    $metaRecord = $rt->query->metaData[substr($filter->getName(),2)];
                    $pref = $rt->kennzeichen.':';
                    if (array_search(substr($filter->getName(),2), $rt->query->valueVars) !== false)
                        if (!($metaRecord->filterType == MetaRecord::SONDERFILTER
                        || $metaRecord->filterType == MetaRecord::SONDERFILTERSEL))
                        $star = '* ';                        
                }
            }else
                if (substr($filter->getName(),1,1)== '='){
                    $rt = $query->repTables->get(substr($filter->getName(),0,1));
                    if ($rt != null){
                        $metaRecord = $rt->query->metaData[substr($filter->getName(),2)];
                        $pref = $rt->kennzeichen.'=';
                        $star = '?* ';
                    }
            }else{
                $metaRecord = $query->metaData[$filter->getName()];
                if (array_search($filter->getName(), $query->valueVars) !== false)
                    if (!($metaRecord->filterType == MetaRecord::SONDERFILTER
                        || $metaRecord->filterType == MetaRecord::SONDERFILTERSEL))
                    $star = '* ';                    
            }
            if ($metaRecord == null) $label = "FEHLER: Keine Metadaten für ".$filter->getName();
            else $label = $metaRecord->label;
            ?>
            <div class="nowrap" >
            <b <?=makeTitleClass(makeFilterTitleDescription($metaRecord),'') ?>><?=$star.$pref.$label?></b>
            <?php
            enterFilterSpec('AddFilter', $i,$filter->getName(), $filter->fs_von, $filter->fs_bis);
            ?>
           &nbsp;&nbsp;
            <div class="nowrap right">
            <img src="./icons/go-up.png"   alt="<?=WSRTranslate::translate("links") ?>"
                title="<?=WSRTranslate::translate("nach oben (links) verschieben") ?>" class="icon" onclick="moveUp('AddFilter',<?=$i?>)" />
            <img src="./icons/go-down.png" alt="<?=WSRTranslate::translate("rechts") ?>"
 				title="<?=WSRTranslate::translate("nach unten (rechts) verschieben") ?>" class="icon" onclick="moveDown('AddFilter',<?=$i?>)" />
     		<img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen") ?>"
				title="<?=WSRTranslate::translate("Zeile löschen") ?>" class="icon" onclick="deleteVar('AddFilter',<?=$i?>)" />
            </div>
            </div><br>
            <?php
            
        }
    } // if qFilter != null
    ?>
    
  <hr>
<div class="nowrap"><?=WSRTranslate::translate("hinzufügen:")?>
<select name="selAddFilter" onchange="addVar('AddFilter',this.value)">
<option value="--" >--</option>
<?php
for ($i=0; $i < $query->repFilter->size(); $i++){
    $rf = $query->repFilter->getPos($i);
    if ($rf->isSet()) continue;
    if ($rf->isWindowFilter()) continue;
    if ($query->addFilter->has($rf->getName())) continue;
    $metaRecord = $query->getReportMetaRecord($rf->getName());
    if (substr($rf->getName(),1,1) == ':') $pref = substr($rf->getName(),0,2);
    else $pref = '';
?>
<option value="<?=$rf->getName() ?>" ><?=$pref.$metaRecord->label?></option>

<?php     
}
?>
</select>

</div>
