<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der Filter-Spezifikation des Report-Editors
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.6.2022 ms
 *
 */
global $query;
require_once './includes/enterFilterSpec.inc';
if (isValid($query->repWerteBasis)){
    if (!isValid($query->repWerteAuswahl)) $query->repWerteAuswahl = $query->repWerteBasis;
?>
<div >
            <div class="nowrap" >
            <b class='help' title="<?=WSRTranslate::translate("Alternative Werte-Auswahl")?>"><?=WSRTranslate::translate("Werte")?></b>
<select onchange="setQAttribute('repWerteAuswahl',this.value)">
<?php 
$mr = $query->getReportMetaRecord('WSR_WERTELISTE');
if ($mr != null){
    $liste = $mr->getSelectOptions();
    foreach ($liste as $wert ){
?>
<option value='<?=$wert[0] ?>' <?= checkSel($wert[0], $query->repWerteAuswahl)?>><?=$wert[1] ?></option>
<?php
    }
}
?>
</select>
       </div>
            in Überschrift anzeigen
            <select  onchange="setQAttribute('repWerteAuswahlTitel',this.value)" class="small" >
            <option value="0" <?=checkSel("0",$query->repWerteAuswahlTitel) ?>>---</option>
            <option value="1" <?=checkSel("1",$query->repWerteAuswahlTitel) ?>>in 1. Zeile</option>
            <option value="2" <?=checkSel("2",$query->repWerteAuswahlTitel) ?>>in 2. Zeile</option>
            <option value="3" <?=checkSel("3",$query->repWerteAuswahlTitel) ?>>in 3. Zeile</option>
            <option value="4" <?=checkSel("4",$query->repWerteAuswahlTitel) ?>>in 4. Zeile</option>
            </select>
           <span class="help" title=
"<?=WSRTranslate::translate("In der Titel-Zeile kann die Werte-Auswahl
mit oder ohne den Text &quot;Werte:&quot;
angezeigt werden")?>"           
           ><input type="checkbox" <?= checked($query->repWerteAuswahlLabel) ?> onchange="setQAttribute('repWerteAuswahlLabel',this.checked)">
            <?=WSRTranslate::translate("mit Label")?></span>            
            <input type="checkbox" <?= checked($query->repWerteAuswahlSelector) ?> onchange="setQAttribute('repWerteAuswahlSelector',this.checked)">
            <?=WSRTranslate::translate("Selector im Output")?>

</div>
<hr>
<?php 
}

    $qFilter = $query->repFilter;
    if ($qFilter != null){
        for ($i = 0; $i < $qFilter->size(); $i++){
            $cl = "nowrap ";
            if ($i % 2 == 0)$cl .= " lw";
            $filter = $qFilter->getPos($i);
            $rt = null;
            $pref = '';
            $star = '';
            if ($filter->isWindowFilter()){
               $metaRecord = $filter->getMetaRecord();
               $star = '# ';
            }else
                $metaRecord = $query->getReportMetaRecord($filter->getName());
            
            if (substr($filter->getName(),1,1)== ':'){
                $rt = $query->repTables->get(substr($filter->getName(),0,1));
                if ($rt != null){
                    $pref = $rt->kennzeichen.':';
                    if (array_search(substr($filter->getName(),2), $rt->query->valueVars) !== false)
                        if (!($metaRecord->filterType == MetaRecord::SONDERFILTER
                        || $metaRecord->filterType == MetaRecord::SONDERFILTERSEL))
                        $star = '* ';                        
                }else{
                    ?>
            <div class="<?=$cl ?> top" >
            <div class="inlineBlock"><b><?=WSRTranslate::translate("FEHLER:")?></b>
            	 <?=WSRTranslate::translate("Keine Datenquelle für")?> <?=$filter->getName()?></div>
                 <div class="nowrap right inlineBlock">
            	<img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen")?>" 
            	    title="<?=WSRTranslate::translate("Filter löschen")?>" class="icon" onclick="deleteVar('Filter',<?=$i?>)" />
            </div>
             </div>
            <br>
            
<?php                             
                    continue;
                }
            }else
                if (substr($filter->getName(),1,1)== '='){
                    $rt = $query->repTables->get(substr($filter->getName(),0,1));
                    if ($rt != null){
                        $pref = $rt->kennzeichen.'=';
                        $star = '* ';
                    }else{
                        ?>
            <div class="<?=$cl ?> top" >
            <div class="inlineBlock"><b><?=WSRTranslate::translate("FEHLER:")?></b>
            	 <?=WSRTranslate::translate("Keine Datenquelle für")?> <?=$filter->getName()?></div>
                <div class="nowrap right inlineBlock">
            	<img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen")?>" 
            	title="<?=WSRTranslate::translate("Filter löschen")?>" class="icon" onclick="deleteVar('Filter',<?=$i?>)" />
            </div>
             </div>
            <br>
            
<?php                             
                    continue;
                    }
            }else{
                if (array_search($filter->getName(), $query->valueVars) !== false)
                    if (!($metaRecord->filterType == MetaRecord::SONDERFILTER
                        || $metaRecord->filterType == MetaRecord::SONDERFILTERSEL))
                    $star = '* ';                    
            }

            if ($metaRecord == null) 
                $label = WSRTranslate::translate("FEHLER:").' '.WSRTranslate::translate(" Keine Metadaten für").' '.$filter->getName();
            else if ($metaRecord->hidden) continue;
            else $label = $metaRecord->label;
            
//            if ($metaRecord->filterType == MetaRecord::WINDOWFILTER) $star = '* ';
            $description = makeFilterTitleDescription($metaRecord);
                    ?>
            <div class="<?=$cl?>" <?php drop("'Filter'", $i, 'drop')?>>
            <div class="nowrap" >
            <span <?php drag("'Filter'", $i, 'drop')?>>
            <b <?=makeTitleClass($description,'') ?> ><?=$star.$pref.$label?></b></span>
            <?php
            
            enterFilterSpec('Filter', $i,$filter->getName(), $filter->fs_von, $filter->fs_bis);
            ?>
           &nbsp;&nbsp;
            <div class="nowrap right">
            <img src="./icons/go-up.png"   alt="<?=WSRTranslate::translate("links")?>" 
            	title="<?=WSRTranslate::translate("nach oben (links) verschieben")?>" class="icon" onclick="moveUp('Filter',<?=$i?>)" />
            <img src="./icons/go-down.png" alt="<?=WSRTranslate::translate("rechts")?>" 
            	title="<?=WSRTranslate::translate("nach unten (rechts) verschieben")?>" class="icon" onclick="moveDown('Filter',<?=$i?>)" />
            <img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen")?>" 
            	title="<?=WSRTranslate::translate("Filter löschen")?>" class="icon" onclick="deleteVar('Filter',<?=$i?>)" />
            </div>
            
            
            <br><?=WSRTranslate::translate("in Überschrift anzeigen")?>
            <select  onchange="setPosAttribute('Filter',<?= $i ?>,'inTitelZeile',this.value)" class="small" >
            <option value="0" <?=checkSel("0",$filter->inTitelZeile) ?>>---</option>
            <option value="1" <?=checkSel("1",$filter->inTitelZeile) ?>><?=WSRTranslate::translate("in 1. Zeile")?></option>
            <option value="2" <?=checkSel("2",$filter->inTitelZeile) ?>><?=WSRTranslate::translate("in 2. Zeile")?></option>
            <option value="3" <?=checkSel("3",$filter->inTitelZeile) ?>><?=WSRTranslate::translate("in 3. Zeile")?></option>
            <option value="4" <?=checkSel("4",$filter->inTitelZeile) ?>><?=WSRTranslate::translate("in 4. Zeile")?></option>
            </select>
           <span class="help" title=
"<?=WSRTranslate::translate("In der Titel-Zeile kann der gesetzte Filter
mit oder ohne die Filter-Beschreibung
angezeigt werden")?>"           
           ><input type="checkbox" <?= checked($filter->inTitelMitLabel) ?> onchange="setPosAttribute('Filter',<?= $i ?>,'inTitelMitLabel',this.checked)">
            <?=WSRTranslate::translate("mit Label")?></span>            
            
<?php if (! $filter->isWindowFilter()){?>            
            &nbsp;&nbsp;&nbsp;wirksam
            <select  onchange="setPosAttribute('Filter',<?= $i ?>,'abSpalte',this.value)" class="small" >
            <option value="0" <?=checkSel("0", $filter->abSpalte) ?> ><?=WSRTranslate::translate("ganze Tabelle")?></option>
            <?php
            $qRows = $query->repRows;
            if ($qRows != null){
                for ($j = 0; $j < $qRows->size(); $j++){
                    if ( ! $qRows->getPos($j)->webLinkColumn){
                    $mr = $query->metaData[$qRows->getPos($j)->getName()];
                    
                    /// ALLES FALSCH ??
                    ?>
                    <option value="<?=$j+1 ?>" <?=checkSel($j+1, $filter->abSpalte) ?> ><?=WSRTranslate::translate("ab")?> <?=$mr->label?></option>
                    <?php
                    }
                }
            }
            ?>
            </select>
            <?php
            }
            if ($metaRecord->filterType != MetaRecord::LIST){
            ?>
            <br>
            <input type="checkbox" <?= checked($filter->selectorImOutput) ?> onchange="setPosAttribute('Filter',<?= $i ?>,'selectorImOutput',this.checked)">
            <?=WSRTranslate::translate("Selector im Output")?>            
            <input type="checkbox" <?= checked($filter->reportCopyFilter) ?> onchange="setPosAttribute('Filter',<?= $i ?>,'reportCopyFilter',this.checked)">
            <span class="help" title=
"<?=WSRTranslate::translate("Normalerweise werden Filter aus der Report-Definition 
beim Aufruf über die Links nicht übergeben.
Mit dieser Option wird der Filter so übergeben, als
wäre er im Aufruf gesetzt")?>"
            ><?=WSRTranslate::translate("Filter übergeben")?></span>
            <input type="checkbox" <?= checked($filter->doNotTake) ?> onchange="setPosAttribute('Filter',<?= $i ?>,'doNotTake',this.checked)">
            <span class="help" title=
"<?=WSRTranslate::translate("Filterwert aus dem Aufruf nicht übernehmen.
Damit können einzelne Filter von der Übernahme
ausgeschlossen werden, während die anderen
übernommen werden.")?>"
            ><?=WSRTranslate::translate("nicht übernehmen")?></span>
            <?php
            }
            
            ?>
            </div><br>
            </div>
            <?php
            
        }
    } // if qFilter != null
    ?>
    
  <hr>
<div class="nowrap">hinzufügen:
<select name="selColumn" onchange="addVar('Filter',this.value)">
<?php
listFilter('-Filter');
if ($query->repTables != null)
    for ($j = 0; $j < $query->repTables->size(); $j++ ){
        $rt = $query->repTables->getPos($j);
            listFilterQueryP('-Filter', $rt->query, $rt->kennzeichen.':',true);
            if ($rt->calcvars != null)
                for ($i=0; $i < count($rt->calcvars); $i++){
//                    error_log('Teste CalcVars '.$rt->calcvars[$i]);
                    if ($query->repValues->has($rt->kennzeichen.'='.$rt->calcvars[$i]))
                        if (! $query->repFilter->has($rt->kennzeichen.'='.$rt->calcvars[$i])){
//                        error_log('nicht in repFilter '.$rt->calcvars[$i]);
                        $name = $rt->calcvars[$i];
                        $metaRecord = $rt->query->metaData[$name];
                        if ($metaRecord == null) echo '<option>'.WSRTranslate::translate("FEHLER").': '.$name.' '
                            .WSRTranslate::translate("hat keine Metadaten").'</option>';
                        else if ($metaRecord->filterType > MetaRecord::NONE)
                            if (! $metaRecord->hidden){
                            ?>
 <option value="<?=$rt->kennzeichen.'='.$name ?>" <?=makeTitle($metaRecord->description)?>><?=$rt->kennzeichen.'='.$metaRecord->label?></option>
            <?php 
                        }
                }
            }
}
?>
 <option value="*windowFilter" title="<?=WSRTranslate::translate("Zusätzlicher Auswahl-Filter")?>"># <?=WSRTranslate::translate("Auswahl-Filter")?></option>

</select>
<span class="help" title="<?=WSRTranslate::translate("Muster zum Einschränken des Auswahlliste")?>"><?=WSRTranslate::translate("Suche")?></span>
<input type="text"  value="<?=$query->repFilterMuster ?>" onchange="setSAttribute('repFilterMuster',this.value,'Filter')" />

</div>
</div>

