<table>
<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der Report-Liste zu einer Datenquelle im Report-Editor
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    19.8.2022 ms
 *
 */
global $query, $compat0;
require_once './phpsec/createDBH.inc';
require_once './includes/classes.inc';

    $sql = new SqlAbfrage('WSR');
    $sprache = 'de';
    if (array_key_exists('Sprache', $_SESSION)) $sprache = substr($_SESSION['Sprache'], 0,2);
    if ($sprache == 'en')
        $sql->sql = "select t.reportID, t.reportTitle_en as  reportTitle from reportTitle t";
    elseif ($sprache == 'fr')
        $sql->sql = "select t.reportID, t.reportTitle_fr as  reportTitle from reportTitle t";
    else
        $sql->sql = "select t.reportID, t.reportTitle_de as  reportTitle from reportTitle t";
    if (isset($compat0)) $sql->sql .= "\n left join reportDefinitionen d on d.reportTitle = t.reportTitle_de and d.SatzTyp = 0";
    $sql->sql .= "\n left join reportAttributes a on a.reportID = t.reportID";    
    $sql->addSel('a.table_name = ', $query->class_table);
    if (isset($compat0)) $sql->addKlausel('or d.reportDef7 = ', $query->class_table);
    $sql->sql .= " order by reportTitle";
    $res = $sql->execute();
    while($z = $res->fetchObject()) {
?>
        <tr>
        <td><a href="./outputReport.php?report=<?=$z->reportTitle?>&action=fromEditor" target="WSReportOutput"><?=$z->reportTitle?></a></td>
        <td><button onclick="loadReport(<?=$z->reportID?>)"><?=WSRTranslate::translate("Report laden")?></button></td>
        <td><button onclick="exportReportDef(<?=$z->reportID?>)"><?=WSRTranslate::translate("Report exportieren")?></button></td>
        <td><button onclick="deleteReport(<?=$z->reportID?>,'<?=$z->reportTitle?>')">
        <?=iconDelete() ?>
        <?=WSRTranslate::translate("löschen")?></button></td>
        </tr>
        
<?php 
    }
    $res->closeCursor();
?>
        
</table>