<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der Spalten-Spezifikation des Report-Editors
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    6.7.2022
 *
 */

global $query;
require_once './includes/enterFilterSpec.inc';
require_once './includes/classes.inc';
if ($query->repColumns != null){
    for ($colGroup = 0; $colGroup < $query->repColumns->size(); $colGroup ++){
        if ($colGroup > 0){
            echo "<hr>";
        }
        /* aktuell nicht aktiv
        if ($colGroup % 2 == 0) $cl = " draggable lw";
        else $cl = " draggable ";
        */
        $colQuery = $query;
        /**
         * @var RepColumn $cg
         */
        $cg = $query->repColumns->getPos($colGroup);
        $col_name = $cg->column_name;
        $k = '';
//        $pref = '';
        if (substr($col_name, 1,1) == ":"){
            $aq = $query->repTables->get(substr($col_name, 0,1));
            if ($aq != null){
                $k = $aq->kennzeichen.':';
                $pref = $aq->prefix.': ';
//                $col_name = substr($col_name, 2);
                $colQuery = $aq->query;
            }else{
                ?>
            <div class="top" >
            <div class="inlineBlock"><b><?=WSRTranslate::translate("FEHLER")?>:</b> 
            <?=WSRTranslate::translate("Keine Datenquelle für")?> <?=$col_name?></div>
                        <div class="nowrap right inlineBlock">
            	<img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen")?>" 
            	title="<?=WSRTranslate::translate("Spalte löschen")?>" class="icon" onclick="deleteVar('Spalten',<?=$colGroup?>)" />
            </div>
             </div>
            <br>
            
<?php                             
                    continue;
            }
        }
/** Das gibt es doch nicht ???        
        elseif (substr($col_name, 1,1) == "="){
            $aq = $query->repTables->get(substr($col_name, 0,1));
            if ($aq != null){
                $k = $aq->kennzeichen.'=';
                $pref = $aq->prefix.'= ';
//                $col_name = substr($col_name, 2);
                $colQuery = $aq->query;
            }else{
                ?>
            <div class="top" >
            <div class="inlineBlock"><b><?=WSRTranslate::translate("FEHLER")?>:</b> 
            <?=WSRTranslate::translate("Keine Datenquelle für")?> <?=$col_name?></div>
                        <div class="nowrap right inlineBlock">
            	<img src="./icons/delete.png" alt="löschen" title="<?=WSRTranslate::translate("Spalte löschen")?>"
            	 class="icon" onclick="deleteVar('Spalten',<?=$colGroup?>)" />
            </div>
             </div>
            <br>
            
<?php                             
                    continue;
            }
        }
// ENDE GIBT'S NICHT */        
        $metaRecord = $query->getReportMetaRecord($col_name);
        $metaVal = null;
        if (isValid($cg->val_name)) $metaVal =  $query->getReportMetaRecord($cg->val_name);
   error_log($cg->val_name.print_r($metaVal,true));
        $valTitle = "";
        if ($metaVal != null) $valTitle = makeTitleClass(makeTitleDescription($metaVal),'');
        $metaFilter = null;
        if (isValid($cg->filter)) $metaFilter =  $query->getReportMetaRecord($cg->filter);
        $filterTitle = "";
        if ($metaFilter != null) $filterTitle = makeTitleClass(makeTitleDescription($metaFilter),'');
        
        if ($metaRecord == null) {
            echo WSRTranslate::translate("FEHLER").': '.WSRTranslate::translate("Keine Metadaten für").' '.$col_name ;
?>            
            <div class="nowrap right">
            <img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen")?>"
             title="<?=WSRTranslate::translate("Spalte löschen")?>" class="icon" onclick="deleteVar('Spalten',<?=$colGroup?>)" />
            </div>
  <?php           
        }else{
        ?>
        <div class="nowrap draggable" <?php drop("'Spalten'", $colGroup, 'drop')?>>
        <span <?=makeTitleClass(makeTitleDescription($metaRecord),'') ?> <?php drag("'Spalten'", $colGroup, 'drop')?>>
        <?=$colGroup+1 ?>. <?=WSRTranslate::translate("Spalten-Gruppe")?>: <b><?=$k.$metaRecord->label ?></b></span>
            <div class="nowrap right">
            <img src="./icons/go-up.png"   alt="<?=WSRTranslate::translate("links")?>"
             title="<?=WSRTranslate::translate("nach oben (links) verschieben")?>"
              class="icon" onclick="moveUp('Spalten',<?=$colGroup?>)" />
            <img src="./icons/go-down.png" alt="<?=WSRTranslate::translate("rechts")?>"
             title="<?=WSRTranslate::translate("nach unten (rechts) verschieben")?>" 
             class="icon" onclick="moveDown('Spalten',<?=$colGroup?>)" />
            <img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen")?>"
             title="<?=WSRTranslate::translate("Spalte löschen")?>" 
             class="icon" onclick="deleteVar('Spalten',<?=$colGroup?>)" />
            </div>
           
           <br><span <?=$valTitle?>>
            <?php
            if ($query->values_in_columns){
                ?>
<span class="help" title=
"<?=WSRTranslate::translate("Bei Werten in Spalten muss hier angegeben
werden, nach welchem Wert in dieser Spalte
sortiert wird.")?>"><?=WSRTranslate::translate("sortieren nach")?></span>: 
                <select name="selColValue" onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'val_name',this.value)">
                <option value="" >--</option>
                <?php
                if ($query->repValues != null)
                    for ($i=0; $i < $query->repValues->size(); $i++){
                        if ($query->repValues->getPos($i)->isWindowValue()) continue;
                        $name = $query->repValues->getPos($i)->getName();
                        $metaRecord = $query->getReportMetaRecord($name);
                        if ($metaRecord == null) $label = WSRTranslate::translate("FEHLER").': '.$name.' '
                                .WSRTranslate::translate("hat keine Metadaten");
                            else $label = $metaRecord->label;
                            ?>
 <option value="<?=$name ?>" <?=makeTitle($metaRecord->description)?> <?=checkSel($name,$cg->val_name)?>
      ><?=$label?></option>
<?php
}
?>
    </select>
<?php                 
            }else {  // Wert für Anzeige
                                
?>                
            Werte:    <select name="selColValue" onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'val_name','<?=$k?>'+this.value)">
                <option value="" >--</option>
                <?php
                if ($colQuery->valueVars != null)
                    for ($i=0; $i < count($colQuery->valueVars); $i++){
                            $name = $colQuery->valueVars[$i];
                            $metaRecord = $colQuery->getReportMetaRecord($name);
                            if ($metaRecord == null) $label = WSRTranslate::translate("FEHLER").': '.$name.' '
                                                            .WSRTranslate::translate("hat keine Metadaten");
                            else $label = $metaRecord->label;
                            ?>
 <option value="<?=$name ?>" <?=makeTitle($metaRecord->description)?> <?=checkSel($k.$name,$cg->val_name)?>
      ><?=$label?></option>
<?php
}
//   TEST FÜR SPALTENAUSWAHL MIT REPTABLES 
if ($query->repTables != null && substr($col_name,1,1) != ':')
    for ($j = 0; $j < $query->repTables->size(); $j++ ){
        $rt = $query->repTables->getPos($j);
        if ($rt->joinType == JoinedTable::JOINWERTE
            || $rt->joinType == JoinedTable::JOINOUTERWERTE){
                if ($rt->query->valueVars != null)
                    for ($i=0; $i < count($rt->query->valueVars); $i++)
  //                      if (! $query->repValues->has($rt->kennzeichen.':'.$rt->query->valueVars[$i]))
  {
                            $name = $rt->query->valueVars[$i];
                            $metaRecord = $rt->query->metaData[$name];
                            if ($metaRecord == null) echo '<option>'.WSRTranslate::translate('FEHLER').': '.$name.' '
             .WSRTranslate::translate('hat keine Metadaten').'</option>';
             if (!isValid($query->repValuesMuster) || (stripos($metaRecord->label, trim($query->repValuesMuster)) !== false))
                 if (! $metaRecord->hidden && ! $metaRecord->enterValue){
                     ?>
 <option value="<?=$rt->kennzeichen.':'.$name ?>" <?=makeTitle($metaRecord->description)?>
 <?=checkSel($rt->kennzeichen.':'.$name,$cg->val_name)?>><?=$rt->kennzeichen.':'.$metaRecord->label?></option>
<?php
    }
   }
            if ($rt->calcvars != null)
                for ($i=0; $i < count($rt->calcvars); $i++)
                    if (! $query->repValues->has($rt->kennzeichen.'='.$rt->calcvars[$i])){
                        $name = $rt->calcvars[$i];
                        $metaRecord = $rt->query->metaData[$name];
                        if ($metaRecord == null) echo '<option>'.WSRTranslate::translate('FEHLER').': '.$name.' '
                    .WSRTranslate::translate('hat keine Metadaten').'</option>';
                        if (!isValid($query->repValuesMuster) || (stripos($metaRecord->label, trim($query->repValuesMuster)) !== false))
                            if (! $metaRecord->hidden){
                            ?>
 <option value="<?=$rt->kennzeichen.'='.$name ?>" <?=makeTitle($metaRecord->description)?>
 <?=checkSel($rt->kennzeichen.'='.$name,$cg->val_name)?>><?=$rt->kennzeichen.'='.$metaRecord->label?></option>
<?php
                        }
            }
              
        }
}
                
                
// ENDE TEST FÜR SPALTENAUWAHL                
?>
    </select>
<?php                 
                // WerteListe
            }
                ?>
			</span>
			
			
			
            <?php
            if (isValid($cg->val_name) && ! $query->values_in_columns){                
                $sel = $cg->displayOption;                
                ?>
                <select onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'displayOption',this.value)">
                <option value="<?=DisplayOptions::ZAHL?>"  <?=checkSel(DisplayOptions::ZAHL,$sel) ?> ><?=WSRTranslate::translate('nur Zahlen')?></option>
                <option value="<?=DisplayOptions::VBAR?>" <?=checkSel(DisplayOptions::VBAR,$sel) ?>><?=WSRTranslate::translate('vert. Balken')?></option>
                <option value="<?=DisplayOptions::HBAR?>" <?=checkSel(DisplayOptions::HBAR,$sel) ?>><?=WSRTranslate::translate('hor. Balken')?></option>
                <option value="<?=DisplayOptions::ZAHLVBAR?>" <?=checkSel(DisplayOptions::ZAHLVBAR,$sel) ?>><?=WSRTranslate::translate('vert. Balken und Zahlen')?></option>
                <option value="<?=DisplayOptions::ZAHLHBAR?>" <?=checkSel(DisplayOptions::ZAHLHBAR,$sel) ?>><?=WSRTranslate::translate('hor. Balken und Zahlen')?></option>
                </select>
<?php
if ($sel != DisplayOptions::ZAHL){
    $skalierung = $cg->skalierung;
?>
<?=WSRTranslate::translate('Skalierung')?>: 
            <select onchange="setPosAttribute('Spalten',<?=$colGroup?>,'skalierung',this.value)">
            <option value="<?=ChartOptions::SKALIEREGRUPPE?>"  <?=checkSel(ChartOptions::SKALIEREGRUPPE,$skalierung) ?> ><?=WSRTranslate::translate('nach Gruppen')?></option>
            <option value="<?=ChartOptions::SKALIEREWERT?>"  <?=checkSel(ChartOptions::SKALIEREWERT,$skalierung) ?> ><?=WSRTranslate::translate('diesen Wert')?></option>
            <option value="<?=ChartOptions::SKALIEREZEILE?>"  <?=checkSel(ChartOptions::SKALIEREZEILE,$skalierung) ?> ><?=WSRTranslate::translate('nach Zeilen')?></option>
            <option value="<?=ChartOptions::SKALIERESPALTE?>"  <?=checkSel(ChartOptions::SKALIERESPALTE,$skalierung) ?> ><?=WSRTranslate::translate('diese Spaltengruppe')?></option>
            <option value="<?=ChartOptions::SKALIERETABELLE?>"  <?=checkSel(ChartOptions::SKALIERETABELLE,$skalierung) ?> ><?=WSRTranslate::translate('ganze Tabelle')?></option>
            </select>
 
<?php 
}
echo "\n<br>".WSRTranslate::translate('Funktion').":\n";
echo "<select onchange=\"setPosAttribute('Spalten',{$colGroup},'function',this.value)\">\n";

foreach (RepValue::functions as $f=>$t){
?>            
            <option value="<?=$f?>"  <?=checkSel($f,$cg->function) ?> 
            title="<?=RepValue::getFunctionDesc($f)?>"><?=WSRTranslate::translate($t) ?></option>
<?php
}
?>
</select>
<?php 
if ($cg->function>0){
    echo '&nbsp;&nbsp;&nbsp;&nbsp;';
    echo WSRTranslate::translate('in Zeilen:');
    $lrow = 0;
    for($ir = $query->repRows->size() -1; $ir > 0 &&  $query->repRows->getPos($ir)->webLinkColumn ; $ir--){
        $lrow --;
    }
?>
           <select  onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'abSpalte',this.value)" class="small" >
            <option value="0" <?=checkSel("0", $cg-> abSpalte) ?> ><?=WSRTranslate::translate("ganze Tabelle")?></option>
<?php
            $qRows = $query->repRows;
            if ($qRows != null){
                for ($j = 0; $j < $qRows->size() + $lrow; $j++){
                    if ( ! $qRows->getPos($j)->webLinkColumn){
                    $mrRow = $query->metaData[$qRows->getPos($j)->getName()];
                    
                    /// ALLES FALSCH ??
                    ?>
                    <option value="<?=$j+1 ?>" <?=checkSel($j+1, $cg->abSpalte) ?> ><?=WSRTranslate::translate("ab")?> <?=$mrRow->label?></option>
                    <?php
                    }
                }
            }
//            error_log($cg->getName().print_r($cg,true)."\nC:".checked($cg->nachSpalten));
            ?>
            </select>
             &nbsp;&nbsp;<input type="checkbox" <?=checked($cg->nachSpalten)?>
            onchange="setPosAttribute('Spalten',<?= $colGroup ?>,'nachSpalten',this.checked)"> <?=WSRTranslate::translate('nach Spalten')?>
            <br>
            <?php
            
}   
?>
             
             
                
                <?php
            } // If Val_name is set
//            if ($query->getColValSelection($colGroup) != null || $query->valuesInColumns){
                $keineSummen = '';
                if ($cg->keineSummen) $keineSummen = "checked";
                ?>
                <br>
                <?=WSRTranslate::translate('Label')?>: <input type="text" onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'label',this.value)" class="white"
                    value="<?=$cg->label ?>" />
                    Sort.:
            <select class="small" onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'sort',this.value)">
<?php
            foreach (Sort::klartext as $sn => $st){
               if ($sn > 0)
                   echo  '<option value="'.$sn.'" '.checkSel($sn,$cg->sort).' >'.WSRTranslate::translate($st)."</option>\n";
            }
?> 	 
            </select>
                    
                    
                    
                    <input type="checkbox" <?=$keineSummen?> onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'keineSummen',this.checked)">
                    <?=WSRTranslate::translate('keine Summen')?>
                    <br>
<?php                 
                // FilterListe
$mrf = null;                
if (isValid($cg->filter)){
    $mrf = $query->getReportMetaRecord($cg->filter);
    if ($mrf != null) echo '<span '.makeTitleClass(makeTitleDescription($mrf), '').'>';
}
    ?>
                    Zusatz-Filter:
                    
                    <select name="selValue" onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'filter','<?=$k?>'+this.value)">
                    <?php
                    listFilterQueryC(substr($cg->filter,strlen($k)),$colQuery);

?>
    </select>
<?php                 
                // FilterListe
if (isValid($cg->filter)){
//    if (isValid($cg->filter)
        if ( $mrf != null) echo '</span>';
        enterFilterSpecQuery('Spalten', $colGroup, substr($cg->filter,strlen($k)), $cg->fs_von, $cg->fs_bis,$colQuery);
}
                        ?>
        
        <br>
        <span class="help" title="<?=WSRTranslate::translate('Hier muss der Name eines 
aufzurufenden Reports angegeben werden.
Ein externer Link mit #, wie bei den Zeilen, ist hier nicht möglich.
Auswahlliste mit Muster ?')?>"><?=WSRTranslate::translate('verl. Report')?></span>:
        <input type="text" class="white" value="<?=$cg->web_link ?>" size="45"
            onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'web_link',this.value)" />
            <br>
<?php 
if ($query->showMuster == 202 && $query->musterZiel == $colGroup){
    // Reportauswahl anzeigen
    $liste = $query->musterListe;
    echo WSRTranslate::translate('Report-Auswahl (ggf. anklicken)').':<br><table>';
    foreach ($liste as $name => $label){
        ?>
<tr <?=makeTitle($label[1])?>><th class="left" onclick="setPosAttribute('Spalten',<?=$colGroup ?>,'web_link','<?=$name ?>')"><?=$label[0] ?></th>
</tr>
    <?php
	 }
	 ?>
	 <tr>
	 <th onclick="closeMuster(202)" >schließen</th></tr>
	 </table>	 
<?php
            }
// Das Überschreiben des Link-Titels             
            if (isValid($cg->web_link) ){
?>            
        <span class="help" title="<?=WSRTranslate::translate('Beschreibung zum Aufruf')?>"><?=WSRTranslate::translate('Beschreibung')?>:</span>:
        <input type="text" class="white" value="<?=$cg->web_title ?>" size="45"
            onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'web_title',this.value)" />
            <br>
<span class="help" title="<?=WSRTranslate::translate('Name des Fensters
leer: im selben Fenster
_blank: in neuem Fenster
Fenstername')?>"><?=WSRTranslate::translate('Fenster')?>:</span>:
        <input type="text" class="white" value="<?=quoteForText($cg->web_target) ?>" size="45"
            onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'web_target',this.value)" />
            <br>  
            <input type="checkbox" onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'reportCopyFilter',this.checked)"
                <?=checked($cg->reportCopyFilter) ?> /> <span class="help" title=
"<?=WSRTranslate::translate('Wenn diese Option gesetzt ist, werden zusätzlich die 
Filter aus dem Aufruf (addFilter-Parameter) übergeben.
Die Filter aus der Report-Definition selbst, werden 
nur übergeben, wenn die Option \'Filter übernehmen\' 
gesetzt ist.')?>"
><?=WSRTranslate::translate('Filter übernehmen')?></span>
                
                <input type="checkbox" onchange="setPosAttribute('Spalten',<?=$colGroup ?>,'reportLinkInValues',this.checked)"
                <?=checked($cg->reportLinkInValues) ?> /> <?=WSRTranslate::translate('Link in Spalten-Werten')?>
                    
<?php 
        }
?>                    
		</div>

                                
<?php

// 		<pre><?php var_dump($query->repColumns->getPos($colGroup)) ? ></pre>
        } // nach Prüfung Metadaten
        } // Schleife ??
        } // if repColumns != null
?>
<hr>
<div class="nowrap"><?=WSRTranslate::translate('hinzufügen')?>:
<select name="selColumn" onchange="addVar('Spalten',this.value)">
<option value="" >--</option>
<?php
if ($query->rowVars != null)
    for ($i=0; $i < count($query->rowVars); $i++)
        if ($query->repRows == null || !$query->repRows->has($query->rowVars[$i])
            ){
                $name = $query->rowVars[$i];
                $metaRecord = $query->getReportMetaRecord($name);
                if ($metaRecord == null) $label = WSRTranslate::translate('FEHLER').': '.$name.' '
                        .WSRTranslate::translate('hat keine Metadaten');
                else if ($metaRecord->hidden) continue;
                else
                if (!isValid($query->repColumnsMuster) || (stripos($metaRecord->label, trim($query->repColumnsMuster)) !== false)){
                    ?>
 <option value="<?=$name ?>" <?=makeTitle($metaRecord->description)?>><?=$metaRecord->label?></option>
<?php
                }
            }
    
if ($query->repTables!= null)
    for ($a=0; $a < $query->repTables->size(); $a++)
        if ($query->repTables->getPos($a)->joinType == JoinedTable::JOINSPALTEN){
            $jt = $query->repTables->getPos($a);
            $k = $jt->kennzeichen;
            $colQuery = $jt->query;
            for ($i=0; $i < count($colQuery->rowVars); $i++){
                $name = $k.':'.$colQuery->rowVars[$i];
                        $metaRecord =$query->getReportMetaRecord($name);
                        if ($metaRecord == null) $label = WSRTranslate::translate('FEHLER').': '.$name.' '
                                    .WSRTranslate::translate('hat keine Metadaten');
                        else if ($metaRecord->hidden) continue;
                        if (!isValid($query->repColumnsMuster) || (stripos($metaRecord->label, trim($query->repColumnsMuster)) !== false)){
                            ?>
 <option value="<?=$name ?>" <?=makeTitle($metaRecord->description)?>><?=$k.': '.$metaRecord->label?></option>
<?php
                        }
            }
    }
?>
</select>
<span class="help" title="<?=WSRTranslate::translate('Muster zum Einschränken des Auswahlliste')?>"><?=WSRTranslate::translate('Suche')?></span>
<input type="text"  value="<?=$query->repColumnsMuster ?>" onchange="setSAttribute('repColumnsMuster',this.value,'Spalten')" />

</div>


