<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der Werte-Spezifikation des Report-Editors
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    30.01.2023 ms
 *
 */
global $query;
    $qVals = $query->repValues;
    if ($qVals != null){
        for ($i = 0; $i < $qVals->size(); $i++){
            /**
             * @var RepValue $qVal
             */
            $qVal = $qVals->getPos($i);
            $sel = $qVal->dispVal;
            $cl = "nowrap ";
            if ($i % 2 == 0)$cl .= " lw";
            $name = $qVal->getValueName();
            /**
             * @var string $function
             */
            $function = $qVal->function;
            if (!isValid($function)) $function = 0;
// error_log(print_r($qVal,true));            
            $rt = null;
            $pref = '';
            if (substr($name,1,1)== ':'){
                $rt = $query->repTables->get(substr($name,0,1));
                if ($rt != null){
                    $metaRecord = $rt->query->metaData[substr($name,2)];
                    $pref = $rt->kennzeichen.':';
                }else{
                    ?>
            <div class="<?=$cl ?> top" >
            <div class="inlineBlock"><b><?=WSRTranslate::translate('FEHLER')?>:</b> 
            	<?=WSRTranslate::translate('Keine Datenquelle für')?> <?=$name?></div>
                        <div class="nowrap right inlineBlock">
            	<img src="./icons/delete.png" alt="<?=WSRTranslate::translate('löschen')?>" 
            		title="<?=WSRTranslate::translate('Wert löschen')?>" class="icon" onclick="deleteVar('Werte',<?=$i?>)" />
            </div>
             </div>
            <br>
<?php                             
                    continue;
                }
            }else
                if (substr($name,1,1)== '='){
                    $rt = $query->repTables->get(substr($name,0,1));
                    if ($rt != null){
                        $metaRecord = $rt->query->metaData[substr($name,2)];
                        $pref = $rt->kennzeichen.'=';
                    }else{
                        ?>
            <div class="<?=$cl ?> top" >
            <div class="inlineBlock"><b><?=WSRTranslate::translate('FEHLER')?>:</b> 
            	<?=WSRTranslate::translate('Keine Datenquelle für')?> <?=$name?></div>
                        <div class="nowrap right inlineBlock">
            	<img src="./icons/delete.png" alt="<?=WSRTranslate::translate('löschen')?>" 
            		title="<?=WSRTranslate::translate('Wert löschen')?>" class="icon" onclick="deleteVar('Werte',<?=$i?>)" />
            </div>
             </div>
            <br>
            
<?php                             
                    continue;
                    }
            }else
                $metaRecord = $query->metaData[$name];
    if ($metaRecord == null){
                    ?>
            <div class="<?=$cl ?> top" >
            <div class="inlineBlock"><b><?=WSRTranslate::translate('FEHLER')?>:</b> 
            	<?=WSRTranslate::translate('Keine Datenquelle für')?> <?=$name?></div>
                        <div class="nowrap right inlineBlock">
            	<img src="./icons/delete.png" alt="<?=WSRTranslate::translate('löschen')?>" 
            		title="<?=WSRTranslate::translate('Wert löschen')?>"  class="icon" onclick="deleteVar('Werte',<?=$i?>)" />
            </div>
            
<?php                     
                }else{                
            ?>
            <div class="<?=$cl ?> top" <?php drop("'Werte'", $i, 'drop')?>>

  <div class="nowrap">
  <span  <?php drag("'Werte'", $i, 'drop');
  if ($qVal->isWindowValue()){
  ?>>
         <span <?=makeTitleClass(RepValue::getFunctionDesc($function).":\n".makeTitleDescription($metaRecord),'')?>><b># <?=RepValue::getFunctionText($function).' '.$pref.$metaRecord->label?></b></span></span>
<?php 
                }else{
  ?>>
         <span <?=makeTitleClass(makeTitleDescription($metaRecord),'')?>><b><?=$pref.$metaRecord->label?></b></span></span>
<?php 
                }
?>                   
             <select onchange="setPosAttribute('Werte',<?=$i?>,'dispVal',this.value)">
            <option value="<?=DisplayOptions::ZAHL?>"  <?=checkSel(DisplayOptions::ZAHL,$sel) ?> ><?=WSRTranslate::translate('nur Zahlen')?></option>
            <option value="<?=DisplayOptions::VBAR?>" <?=checkSel(DisplayOptions::VBAR,$sel) ?>><?=WSRTranslate::translate('vert. Balken')?></option>
            <option value="<?=DisplayOptions::HBAR?>" <?=checkSel(DisplayOptions::HBAR,$sel) ?>><?=WSRTranslate::translate('hor. Balken')?></option>
            <option value="<?=DisplayOptions::ZAHLVBAR?>" <?=checkSel(DisplayOptions::ZAHLVBAR,$sel) ?>><?=WSRTranslate::translate('vert. Balken und Zahlen')?></option>
            <option value="<?=DisplayOptions::ZAHLHBAR?>" <?=checkSel(DisplayOptions::ZAHLHBAR,$sel) ?>><?=WSRTranslate::translate('hor. Balken und Zahlen')?></option>
            </select>
<?php
if ($sel != DisplayOptions::ZAHL){
    $skalierung = $qVals->getPos($i)->skalierung;
?>
Skalierung: 
            <select onchange="setPosAttribute('Werte',<?=$i?>,'skalierung',this.value)">
            <option value="<?=ChartOptions::SKALIEREGRUPPE?>"  <?=checkSel(ChartOptions::SKALIEREGRUPPE,$skalierung) ?> ><?=WSRTranslate::translate('nach Gruppen')?></option>
            <option value="<?=ChartOptions::SKALIEREWERT?>"  <?=checkSel(ChartOptions::SKALIEREWERT,$skalierung) ?> ><?=WSRTranslate::translate('diesen Wert')?></option>
            <option value="<?=ChartOptions::SKALIEREZEILE?>"  <?=checkSel(ChartOptions::SKALIEREZEILE,$skalierung) ?> ><?=WSRTranslate::translate('nach Zeilen')?></option>
            <option value="<?=ChartOptions::SKALIERETABELLE?>"  <?=checkSel(ChartOptions::SKALIERETABELLE,$skalierung) ?> ><?=WSRTranslate::translate('Tabelle')?></option>
            </select>
<?php 
}
// if (false) $metaRecord = new MetaRecord();
$label = $metaRecord->label;
if ($qVals->getPos($i)->label != null) $label = $qVals->getPos($i)->label;
else if ($qVals->getPos($i)->function > 0) $label = RepValue::getFunctionText($qVals->getPos($i)->function).' '.$label;
?>          
            <div class="nowrap right inlineBlock">
            <img src="./icons/go-up.png"   alt="<?=WSRTranslate::translate('links')?>" 
            	title="<?=WSRTranslate::translate('nach oben (links) verschieben')?>" class="icon" onclick="moveUp('Werte',<?=$i?>)" />
            <img src="./icons/go-down.png" alt="<?=WSRTranslate::translate('rechts')?>" 
            	title="<?=WSRTranslate::translate('nach unten (rechts) verschieben')?>" class="icon" onclick="moveDown('Werte',<?=$i?>)" />
            <img src="./icons/delete.png" alt="<?=WSRTranslate::translate('löschen')?>" 
            		title="<?=WSRTranslate::translate('Wert löschen')?>"  class="icon" onclick="deleteVar('Werte',<?=$i?>)" />
            </div>
</div> 
<?=WSRTranslate::translate('Funktion')?>: 
            <select onchange="setPosAttribute('Werte',<?=$i?>,'function',this.value)">
<?php 
foreach (RepValue::functions as $f=>$t){
?>            
            <option value="<?=$f?>"  <?=checkSel($f,$function) ?> 
            title="<?=RepValue::getFunctionDesc($f)?>"><?=WSRTranslate::translate($t)?></option>
<?php
}
?>
</select>
<?php 
if ($function>0){
    echo '&nbsp;&nbsp;&nbsp;&nbsp;';
    echo WSRTranslate::translate('in Zeilen:');
    $lrow = 0;
    for($ir = $query->repRows->size() -1; $ir > 0 &&  $query->repRows->getPos($ir)->webLinkColumn ; $ir--){
        $lrow --;
    }
    if (!$query->values_in_columns ||  $qVal->nachSpalten) $lrow --;
    
?>

            <select  onchange="setPosAttribute('Werte',<?= $i ?>,'abSpalte',this.value)" class="small" >
            <option value="0" <?=checkSel("0", $qVal-> abSpalte) ?> ><?=WSRTranslate::translate("ganze Tabelle")?></option>
            <?php
            $qRows = $query->repRows;
            if ($qRows != null){
                for ($j = 0; $j < $qRows->size() + $lrow; $j++){
                    if ( ! $qRows->getPos($j)->webLinkColumn){
                    $mr = $query->metaData[$qRows->getPos($j)->getName()];
                    
                    /// ALLES FALSCH ??
                    ?>
                    <option value="<?=$j+1 ?>" <?=checkSel($j+1, $qVal->abSpalte) ?> ><?=WSRTranslate::translate("ab")?> <?=$mr->label?></option>
                    <?php
                    }
                }
            }
            ?>
            </select>
            <?php
            if ($query->values_in_columns){
            ?>
            &nbsp;&nbsp;<input type="checkbox" <?=checked($qVal->nachSpalten)?>
            onchange="setPosAttribute('Werte',<?= $i ?>,'nachSpalten',this.checked)"> <?=WSRTranslate::translate('nach Spalten')?>
            <?php
            }
}   
?>
<br>
<input type="text" value="<?=$label ?>" onchange="setPosAttribute('Werte',<?=$i ?>,'labelW',this.value)" class="white" size="45" 
title="<?=WSRTranslate::translate('ggf. abweichende Spaltenüberschrift
zurücksetzen mit leerer Eingabe')?>" />
<br>
<?php 
if (substr($name,1,1)== '='){    
?>      
<?=WSRTranslate::translate('Basis')?>
            <select onchange="setPosAttribute('Werte',<?=$i?>,'base',this.value)">
            <option value="base"  <?=checkSel('base',$qVals->getPos($i)->base) ?> ><?=WSRTranslate::translate('Basis-Quelle')?></option>
<?php
for ($j=0; $j < $query->repTables->size();$j++){
    $rt = $query->repTables->getPos($j);
    if (($rt->joinType == JoinedTable::JOINWERTE
        || $rt->joinType == JoinedTable::JOINOUTERWERTE)
        && $rt->kennzeichen != substr($name,0,1)){        
?>            
            <option value="<?=$rt->kennzeichen?>"  <?=checkSel($rt->kennzeichen,$qVals->getPos($i)->base) ?> ><?=$rt->kennzeichen.': '.$rt->prefix?></option>
<?php 
    }
}
?>            
			</select>&nbsp;&nbsp;&nbsp;                          
<?php } ?> 
            <input type="checkbox" <?=checked($qVals->getPos($i)->keineSummen)?> onchange="setPosAttribute('Werte',<?=$i ?>,'keineSummen',this.checked)">
                    <?=WSRTranslate::translate('keine Summen')?>                    
            
<?php }
?>            
&nbsp;&nbsp;<button onclick="farbAuswahl(this,<?=$i ?>)" style="background-color: <?=$qVals->getPos($i)->backgroundColor ?>"><?=WSRTranslate::translate('Hintergrund')?></button>
            </div>
            <br>
            <?php
        }
    }
    ?>
    <hr><div class="nowrap"><?=WSRTranslate::translate('hinzufügen')?>:
    <select name="selValue" onchange="addVar('Werte',this.value)">
 <option value="" >--</option>
<?php 
if ($query->valueVars != null)
    for ($i=0; $i < count($query->valueVars); $i++)
        if (! $query->repValues->has($query->valueVars[$i])){
            $name = $query->valueVars[$i];
        $metaRecord = $query->metaData[$name];
        if ($metaRecord == null) echo WSRTranslate::translate('FEHLER').': '.$name.' '
                                    .WSRTranslate::translate('hat keine Metadaten');
        if (!isValid($query->repValuesMuster) || (stripos($metaRecord->label, trim($query->repValuesMuster)) !== false)){
            if (! $metaRecord->hidden)
            ?>
 <option value="<?=$name ?>" <?=makeTitle($metaRecord->description)?>><?=$metaRecord->label?></option>
<?php
        }
}
if ($query->repTables != null)
    for ($j = 0; $j < $query->repTables->size(); $j++ ){
        $rt = $query->repTables->getPos($j);
        if ($rt->joinType == JoinedTable::JOINWERTE
            || $rt->joinType == JoinedTable::JOINOUTERWERTE){
            if ($rt->query->valueVars != null)
                for ($i=0; $i < count($rt->query->valueVars); $i++)
                    if (! $query->repValues->has($rt->kennzeichen.':'.$rt->query->valueVars[$i])){
                        $name = $rt->query->valueVars[$i];
                        $metaRecord = $rt->query->metaData[$name];
                        if ($metaRecord == null) echo '<option>'.WSRTranslate::translate('FEHLER').': '.$name.' '
                    .WSRTranslate::translate('hat keine Metadaten').'</option>';
    if (!isValid($query->repValuesMuster) || (stripos($metaRecord->label, trim($query->repValuesMuster)) !== false))
        if (! $metaRecord->hidden && ! $metaRecord->enterValue){                            
                        ?>                        
 <option value="<?=$rt->kennzeichen.':'.$name ?>" <?=makeTitle($metaRecord->description)?>><?=$rt->kennzeichen.':'.$metaRecord->label?></option>
<?php
    }
                }
            if ($rt->calcvars != null)
                for ($i=0; $i < count($rt->calcvars); $i++)
                    if (! $query->repValues->has($rt->kennzeichen.'='.$rt->calcvars[$i])){
                        $name = $rt->calcvars[$i];
                        $metaRecord = $rt->query->metaData[$name];
                        if ($metaRecord == null) echo '<option>'.WSRTranslate::translate('FEHLER').': '.$name.' '
                    .WSRTranslate::translate('hat keine Metadaten').'</option>';
                        if (!isValid($query->repValuesMuster) || (stripos($metaRecord->label, trim($query->repValuesMuster)) !== false))
                            if (! $metaRecord->hidden){
                            ?>
 <option value="<?=$rt->kennzeichen.'='.$name ?>" <?=makeTitle($metaRecord->description)?>><?=$rt->kennzeichen.'='.$metaRecord->label?></option>
<?php
                        }
            }
              
        }
}

?>
    </select>
    <span class="help" title="<?=WSRTranslate::translate('Muster zum Einschränken des Auswahlliste')?>"><?=WSRTranslate::translate('Suche')?></span>
<input type="text"  value="<?=$query->repValuesMuster ?>" onchange="setSAttribute('repValuesMuster',this.value,'Werte')" />
    
    </div>
    