<?php
/**
 * Projekt: WS-Reporter
 *          Attribute einer Report-Definition eintragen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 * pos enthält die Position in der jeweiligen Liste
 * tab enthält den Namen der Liste
 * action ist der Befehl
 */
global $query;

// error_log('ersActionPos: '.print_r($_REQUEST,true));

function bereinige($kennz){
    global $query;
    for ($i = $query->repColumns->size() -1; $i >= 0; $i--){
        $name = $query->repColumns->getPos($i)->getName();
        if (strpos($name, $kennz.'=') ===  0
            || strpos($name, $kennz.':') ===  0
            ) $query->repColumns->removePos($i);
    }
    for ($i = $query->repColumns->size() -1; $i >= 0; $i--){
        $name = $query->repColumns->getPos($i)->val_name;
        if (strpos($name, $kennz.'=') ===  0
            || strpos($name, $kennz.':') ===  0
            ) $query->repColumns->getPos($i)->val_name = null;
    }
    for ($i = $query->repValues->size() -1; $i >= 0; $i--){
        $name = $query->repValues->getPos($i)->getName();
        if (strpos($name, $kennz.'=') ===  0
            || strpos($name, $kennz.':') ===  0
            ) {
                $query->repValues->removePos($i);
        }if (substr($name,1,1) == '=' 
            && $query->repValues->getPos($i)->base == $kennz) {
                $query->repValues->getPos($i)->base = 'base';
            }
    }
    
}

function bereinigeFilter($kennz){
    global $query;
    for ($i = $query->repFilter->size() -1; $i >= 0; $i--){
        $name = $query->repFilter->getPos($i)->getName();
        if (strpos($name, $kennz.'=') ===  0
            || strpos($name, $kennz.':') ===  0
            ) $query->repFilter->removePos($i);
    }
}
function bereinigeAddFilter($kennz){
    global $query;
    for ($i = $query->addFilter->size() -1; $i >= 0; $i--){
        $name = $query->addFilter->getPos($i)->getName();
        if (strpos($name, $kennz.'=') ===  0
            || strpos($name, $kennz.':') ===  0
            ) $query->addFilter->removePos($i);
    }
}

/**
 * 
 * @param RepColumn $cg
 */
function makeColumnLabel($cg){
    global $query;
    if (! $query->values_in_columns && isValid($cg->val_name))
        if (substr($cg->column_name,1,1) == ':'){
            $jt = $query->repTables->get(substr($cg->val_name,0,1));
            if ($jt != null){
                $cg->label = $jt->query->metaData[substr($cg->val_name,2)]->label.' nach ';
                $cg->label .= $jt->query->metaData[substr($cg->getVarName(),2)]->label;
            }
    }
    else{
        $cg->label = $query->getReportMetaRecord($cg->val_name)->label.' nach ';
        $cg->label .= $query->metaData[$cg->getVarName()]->label;
        if (substr($cg->val_name, 1,1) == ':'){
            /**             
             * @var JoinedTable $rt
             */
            $rt = $query->repTables->get(substr($cg->val_name, 0,1));
            if ($rt != null ){
                if (isValid($rt->prefix)) $cg->label = $rt->prefix.': '.$cg->label;
            }
            else $cg->label = substr($cg->val_name, 1,1).'?: '.$cg->label;
        }
    }
    if ($cg->function > 0) {
        $cg->label = RepValue::getFunctionText($cg->function).' '.$cg->label;
    }
    error_log('ergibt: '.$cg->label);
    
}

$pos = $_REQUEST['pos'];

if($_REQUEST['action'] == 'addJoin'){
    $aq = $query->addQueries->getPos($pos);  
   if ($aq == null){
       http_response_code(425);
       echo 'Keine Tabelle an Position '.$pos;
       die();
   }
   $join = new JoinedTable($aq);
   if ($join != null && isValid($join->getName())){
       $query->repTables->put($join);
       // Default-Filter kopieren
       foreach($join->query->defaultFilter as $df){
               $f = new RepFilter($join->kennzeichen.':'.$df->column_name);
               $f->fs_von = $df->fs_von;
               $f->fs_bis = $df->fs_bis;
               $query->repFilter->put($f);
       }
   }
   else{
       http_response_code(425);
       echo 'Die Join-Tabelle  null an Position '.$pos;
       die();
       
   }
   return;
}

if($_REQUEST['action'] == 'removeJoin'){
    bereinige($query->repTables->getPos($pos)->kennzeichen);
    bereinigeFilter($query->repTables->getPos($pos)->kennzeichen);
    bereinigeAddFilter($query->repTables->getPos($pos)->kennzeichen);
    $query->repTables->removePos($pos);
    die();
        http_response_code(425);
        echo 'Die Join-Tabelle  null an Position '.$pos;
        die();
        
    
    return;
}
if($_REQUEST['action'] == 'joinType'){
    $jt = $query->repTables->getPos($pos);
    if ($jt != null){
        if (($jt->joinType != $_REQUEST['type'])
            && ($jt->joinType == JoinedTable::JOINSPALTEN
                || $_REQUEST['type'] == JoinedTable::JOINSPALTEN ))
        bereinige($query->repTables->getPos($pos)->kennzeichen);    
        $jt->joinType = $_REQUEST['type'];
        return;
    }
}
if($_REQUEST['action'] == 'joinPrefix'){
    $jt = $query->repTables->getPos($pos);
    if ($jt != null){
        $jt->prefix = $_REQUEST['prefix'];        
        return;
    }
}

// Historisierung
if($_REQUEST['action'] == 'histOption'){
    $dimNr = $_REQUEST['dimNr'];
    if ($pos == 0 ){
        if ($dimNr == 0) $query->historyOption = $_REQUEST['value'];
        else{
            $dim = $query->dimensions[$dimNr];
            if (false) $dim = new Dimension(null);
            $dim->historyOption = $_REQUEST['value'];
        }
    }
    else {
        $jTable = $query->repTables->getPos($pos-1); //->query;
        if (false) $jTable = new JoinedTable(null);
        $jTable->dimHistoryOption[$dimNr] = $_REQUEST['value'];
    }
    return;
}

if($_REQUEST['action'] == 'histDate'){
    $vd = WSRFormats::stdDate($_REQUEST['value']);
    $dimNr = $_REQUEST['dimNr'];
    if ($pos == 0 ){
        if ($dimNr == 0) $query->historyDate = $vd;
        else{
            $dim = $query->dimensions[$dimNr];
            if (false) $dim = new Dimension(null);
            $dim->historyDate = $vd;
            error_log('Distory-Date für '.$dimNr.' ('.$dim->dimName.') ist '.$vd);
        }
    }
    else {
        $jTable = $query->repTables->getPos($pos-1); //->query;
        if (false) $jTable = new JoinedTable(null);
        $jTable->dimHistoryDate[$dimNr] = $vd;
    }
    return;
    return;
}



/**
 * addVar wird in ersAction abgehandelt. Hier ist es wohl
 * ein Überbleibsel aus vergangenen Zeiten.
 */
if ($_REQUEST['action'] == 'addVar'){
    echo 'Fehler bei ersActionPos: Der Aufruf addVar sollte hier nicht vorkommen';
    die();
}

$vVector = 0;
if (isset($_REQUEST['tab'])){
    switch ($_REQUEST['tab']){
        case 'Zeilen':
            if ($_REQUEST['action'] == 'addVar'){
            $v = new RepRow($_REQUEST['var']);
            $query->repRows ->put($v);
            return;            
        }
        $vVector = $query->repRows;
        break;
        case 'Spalten':         
            if ($_REQUEST['action'] == 'addVar'){
            $v = new RepColumn($_REQUEST['var']);
            $query->repColumns ->put($v);
            return;            
        }
        $vVector = $query->repColumns;
        break;
        case 'Werte':         
        if ($_REQUEST['action'] == 'addVar'){
            $v = new RepValue($_REQUEST['var']);
            $query->repValues ->put($v);
            return;            
        }
        $vVector = $query->repValues;
        break;
        case 'Filter':         
            if ($_REQUEST['action'] == 'addVar'){
            $v = new RepFilter($_REQUEST['var']);
            $query->repFilter ->put($v);
            return;
        }
        $vVector = $query->repFilter;
        break;
        case 'AddFilter':
            if ($_REQUEST['action'] == 'addVar'){
                $v = new RepFilter($_REQUEST['var']);
                $query->addFilter ->put($v);
                return;
            }
            $vVector = $query->addFilter;
            break;
        case 'ReportVerweise':
            if ($_REQUEST['action'] == 'addVar'){
                $v = new RepReport($_REQUEST['var']);
                $query->repReports ->put($v);
                return;
            }
            $vVector = $query->repReports;
            break;
    }
}

if ($vVector !=null){
    switch($_REQUEST['action']){
        case 'moveUp': $vVector->upPos($pos);
        return;
        case 'moveDown': $vVector->downPos($pos);
        return;
        case 'moveTo': 
            $nachPos = $_REQUEST['nachPos'];
            $vVector->movePos($pos,$nachPos);
            return;
        break;
        case 'delete':
            if ($_REQUEST['tab'] == 'Filter'){
                $name = $vVector->getPos($pos)->getName();
                $query->addFilter->remove($name);
            }
            $vVector->removePos($pos);
        return;
        case 'setAttribute':
            switch ($_REQUEST['attribute']){
                case 'sort':
                    $vVector->getPos($pos)->sort = 1 * $_REQUEST['value'];
                    return;
                case 'summenZeilen':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->summenZeilen = true;
                    else $vVector->getPos($pos)->summenZeilen = false;
                    return;
                case 'fixedTableColumns':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->fixedTableColumns = true;
                    else $vVector->getPos($pos)->fixedTableColumns = false;
                    return;
                case 'web_link_title':
                    if ($vVector->getPos($pos)->webLinkColumn){
                        if (isValid($_REQUEST['value'])) $vVector->getPos($pos)->web_link_title = $_REQUEST['value'];
                        else  $vVector->getPos($pos)->web_link_title = null;
                        return;
                    }else{
                        echo 'Fehler: Die Zeilen-Spalte ist keine Web-Link-Spalte';
                        die();
                    }
                case 'web_link_value':
                    if ($vVector->getPos($pos)->webLinkColumn){
                        if (isValid($_REQUEST['value'])) $vVector->getPos($pos)->web_link_value = $_REQUEST['value'];
                        else  $vVector->getPos($pos)->web_link_value = null;
                        return;
                    }else{
                        echo 'Fehler: Die Zeilen-Spalte ist keine Web-Link-Spalte';
                        die();
                    }
                case 'web_title':
                    if (isValid($_REQUEST['value'])) $vVector->getPos($pos)->web_title = $_REQUEST['value'];
                    else  $vVector->getPos($pos)->web_title = null;
                    return;
                case 'web_target':
                    if (isValid($_REQUEST['value'])) $vVector->getPos($pos)->web_target = $_REQUEST['value'];
                    else  $vVector->getPos($pos)->web_target = null;
                    return;
                case 'web_link':
                    $web_link = $_REQUEST['value'];
                    if(strpos($web_link, "?") !== FALSE){
                        require_once './phpsec/createDBH.inc';
                        switch ($_REQUEST['tab']){
                            case 'Zeilen':
                                $query->showMuster = 201;
                                break;
                            case 'Spalten':
                                $query->showMuster = 202;
                                break;
                        }    
                        $query->musterZiel = $pos;
                        $query->musterListe = array();
                        if(strpos($web_link, "#") === 0){
                            if(strpos($web_link, "?")>1) $smuster = strtolower(substr($web_link, 1,strpos($web_link, "?")-1));
                            for ($ip=0; $ip < count($query->rowVars); $ip ++){
                                $mr = $query->getReportMetaRecord($query->rowVars[$ip]);
                                if (isset($smuster) 
                                    && strpos(strtolower($mr->label), $smuster) !== 0
                                    && strpos(strtolower($mr->getName()), $smuster) !== 0
                                    ) {
//                                    error_log('Überspringe '.$mr->label.' wg Muster >'.$smuster.'<');
                                    continue;
                                }
                                $t = array();
                                $t[0] = $mr->label;
                                $t[1] = $mr->description;
                                $query->musterListe['#'.$mr->getName()] = $t;
                            }                            
                        }else{
                            $sql = new SqlAbfrage('WSR');
                            $sql->sql = 'select Report, Report_Kommentar, DatenQuelle from reportVerzeichnis';
                            $sql->addSel("Report like ", str_replace('?', '%', trim($web_link)));
                            $sql->sql.= ' order by Report';
                            $stmt = $sql->execute();
                            if ($stmt == false){
                                die();
                            }
                            while ($z = $stmt->fetchObject()) {
                                $t = array();
                                $t[0] = $z->Report;
                                $t[1] = $z->DatenQuelle."\n".$z->Report_Kommentar;;
                                $query->musterListe[$z->Report] = $t;
                            }
                        }
                        $vVector->getPos($pos)->web_link = '';
                        return;
                    }
                    $vVector->getPos($pos)->web_link = $web_link;
                    if ($query->showMuster == 202 || $query->showMuster == 201){
                        $query->showMuster = 0;
                    }
                    return;
                case 'webCopyFilter':    
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->webCopyFilter = true;
                    else $vVector->getPos($pos)->webCopyFilter = false;
                    return;
                case 'dispVal':
                    $vVector->getPos($pos)->dispVal = $_REQUEST['value'];
                    return;
                case 'val_name':
                    $cg =  $vVector->getPos($pos);
                    $cg->val_name = $_REQUEST['value'];
                    // Label Schreiben
                    makeColumnLabel($cg);
                    return;
                case 'displayOption':
                    $vVector->getPos($pos)->displayOption = $_REQUEST['value'];
                    return;
                case 'base':
                    $vVector->getPos($pos)->base = $_REQUEST['value'];
                    return;
                case 'keineSummen':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->keineSummen = true;
                    else $vVector->getPos($pos)->keineSummen = false;
                    return;
                case 'label':
                    $vVector->getPos($pos)->label = $_REQUEST['value'];
                    return;
                case 'backgroundColor':
                    $vVector->getPos($pos)->backgroundColor = $_REQUEST['value'];
                    return;
                case 'labelW':
                    if (isValid($_REQUEST['value']))
                        $vVector->getPos($pos)->label = $_REQUEST['value'];
                        else $vVector->getPos($pos)->label = null;
                    return;
                case 'filter':
                    $vVector->getPos($pos)->filter = $_REQUEST['value'];
                    $vVector->getPos($pos)->fs_von = null;
                    $vVector->getPos($pos)->fs_bis = null;
                    return;
/** nur noch web_link                    
                case 'report_link':
                    error_log("Starte Report-link mit ".$_REQUEST['value']);
                    $web_link = $_REQUEST['value'];
                    if(strpos($web_link, "?") !== FALSE){
                        require_once './phpsec/createDBH.inc';
                        switch ($_REQUEST['tab']){
                            case 'Zeilen':
                                $query->showMuster = 201;
                                break;
                            case 'Spalten':
                                $query->showMuster = 202;
                                break;
                        }
                        $query->musterZiel = $pos;
                        $query->musterListe = array();
                        if(strpos($web_link, "#") === 0){
                            for ($ip=0; $ip < count($query->rowVars); $ip ++){
                                $mr = $query->getReportMetaRecord($query->rowVars[$ip]);
                                $t = array();
                                $t[0] = $mr->label;
                                $t[1] = $mr->description;
                                $query->musterListe['#'.$mr->getName()] = $t;
                            }
                        }else{
                            $sql = new SqlAbfrage('WSR');
                            $sql->sql = 'select Report, Report_Kommentar, DatenQuelle from reportVerzeichnis';
                            $sql->addSel("Report like ", str_replace('?', '%', trim($web_link)));
                            $sql->sql.= ' order by Report';
                            $stmt = $sql->execute();
                            if ($stmt == false){
                                die();
                            }
                            while ($z = $stmt->fetchObject()) {
                                $t = array();
                                $t[0] = $z->Report;
                                $t[1] = $z->DatenQuelle."\n".$z->Report_Kommentar;;
                                $query->musterListe[$z->Report] = $t;
                            }
                        }
                        $vVector->getPos($pos)->report_link = '';
                        return;
                    }
                    $vVector->getPos($pos)->report_link = $web_link;
                    if ($query->showMuster == 202 || $query->showMuster == 201){
                        $query->showMuster = 0;
                    }
                    
                    return;
*/                    
                case 'descending':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->descending = true;
                    else $vVector->getPos($pos)->descending = false;
                    return;
                case 'doNotTake':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->doNotTake = true;
                    else $vVector->getPos($pos)->doNotTake = false;
                    return;
                case 'reportCopyFilter':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->reportCopyFilter = true;
                    else $vVector->getPos($pos)->reportCopyFilter = false;
                    return;
                case 'reportLinkInValues':
                    if ($_REQUEST['value'] == 'true') {
                        if ($query->values_in_columns){
                            http_response_code(425);
                            echo WSRTranslate::translate("Diese Option ist in Verbindung mit\n\"Werte in Spalten\" nicht möglich");
                            return;
                        }
                        $vVector->getPos($pos)->reportLinkInValues = true;
                    }
                    else $vVector->getPos($pos)->reportLinkInValues = false;
                    return;
                case 'fs_von':
                    if ($_REQUEST['tab'] == 'Spalten')
                        $mr = $query->getReportMetaRecord($vVector->getPos($pos)->filter);
                    else 
                        $mr = $query->getReportMetaRecord($vVector->getPos($pos)->getName());     
                    if ($mr != null){
                        $vVector->getPos($pos)->fs_von = $mr->reformatValue($_REQUEST['value']);
//                        error_log($_REQUEST['value'].' ergibt '.$vVector->getPos($pos)->fs_von);
                        return;                            
                    }else if ($vVector->getPos($pos)->isWindowFilter()){
                        $vVector->getPos($pos)->fs_von = WSRFormats::stdNumber($_REQUEST['value']);
//                        error_log($_REQUEST['value'].' ergibt '.$vVector->getPos($pos)->fs_von);
                        return;
                    }
                case 'fs_bis':
                    if ($_REQUEST['tab'] == 'Spalten')
                        $mr = $query->getReportMetaRecord($vVector->getPos($pos)->filter);
                    else
                        $mr = $query->getReportMetaRecord($vVector->getPos($pos)->getName());
                    $vVector->getPos($pos)->fs_bis = $mr->reformatValue($_REQUEST['value']);
                    return;
                case 'fs_bis1':
                    if (array_key_exists('value', $_REQUEST) && isValid($_REQUEST['value'])){
                        error_log('fs_bis1 '.$_REQUEST['value']);
                        error_log(print_r(explode(' ', $vVector->getPos($pos)->fs_bis),true));
                        if (! isValid($vVector->getPos($pos)->fs_bis)
                            ||count(explode(' ', $vVector->getPos($pos)->fs_bis)) != 1
                            )
                            $vVector->getPos($pos)->fs_bis = $_REQUEST['value'].' desc';
                        else
                            $vVector->getPos($pos)->fs_bis = $_REQUEST['value'];                            
                    }else
                        $vVector->getPos($pos)->fs_bis = '';
                        error_log('ergibt fs_bis =  '.$vVector->getPos($pos)->fs_bis);
                        return;
                case 'fs_bis2':
                    error_log('fs_bis2 '.$_REQUEST['value']);
                    $fA = explode(' ',$vVector->getPos($pos)->fs_bis);
                    error_log(print_r($fA,true));
                    if (isValid($fA[0]) && $_REQUEST['value'] == 'false')
                        $vVector->getPos($pos)->fs_bis = $fA[0].' desc';
                    else
                        $vVector->getPos($pos)->fs_bis = $fA[0];
                        error_log('ergibt fs_bis =  '.$vVector->getPos($pos)->fs_bis);
                   return;
                case 'wfWert':
                    $filter = $vVector->getPos($pos);
                    if ($filter->isWindowFilter())
                       $filter->setWert($_REQUEST['value']);
                    return;
                case 'wfType':
                    $filter = $vVector->getPos($pos);
                    if ($filter->isWindowFilter())
                        $filter->setType($_REQUEST['value']);
                        return;
                case 'wfAsc':
                    $filter = $vVector->getPos($pos);
                    if ($filter->isWindowFilter()){
                        if ($_REQUEST['value'] == 'true')
                            $filter->setDesc(false);
                        else
                            $filter->setDesc(true);
                    }
                     return;
                        
                case 'abSpalte':
                    $vVector->getPos($pos)->abSpalte = $_REQUEST['value'];
                    error_log("Set abSpalte = ".$_REQUEST['value']);
                    return;
                case 'nachSpalten':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->nachSpalten = true;
                    else $vVector->getPos($pos)->nachSpalten = false;
                    error_log("Set nachSpalten = ".$_REQUEST['value']."\n".print_r($vVector->getPos($pos),true));
                    return;
                case 'inTitelZeile':
                    $vVector->getPos($pos)->inTitelZeile = $_REQUEST['value'];
                    return;
                case 'inTitelMitLabel':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->inTitelMitLabel = true;
                    else $vVector->getPos($pos)->inTitelMitLabel = false;
                    return;
                case 'selectorImOutput':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->selectorImOutput = true;
                    else $vVector->getPos($pos)->selectorImOutput = false;
                    return;
                case 'skalierung':
                    $vVector->getPos($pos)->skalierung = 1 * $_REQUEST['value'];
                    return;
                case 'kommentar':
                    $vVector->getPos($pos)->kommentar = $_REQUEST['value'];
                    return;
                case 'copyFilter':
                    if ($_REQUEST['value'] == 'true') $vVector->getPos($pos)->copyFilter = true;
                    else $vVector->getPos($pos)->copyFilter = false;
                    return;
                case 'function':
                    /**
                     * Umwandeln eines normalen Werts in WindowValue und umgekehrt
                     * @var RepValue $qVal
                     */
                    $qVal = $vVector->getPos($pos);
                    // Bei Spalten wird einfach das Attribut gesetzt.
                    if ($_REQUEST['tab'] == 'Spalten'){
                        $qVal->function = $_REQUEST['value'];
                        makeColumnLabel($qVal);
                        return;
                    }
                    if (isValid($_REQUEST['value']) && $_REQUEST['value'] > 0){
                        if ($qVal->isWindowValue()){
                            $qVal->function = $_REQUEST['value'];                            
                            return;
                        }
                        // Neuen Namen für diesen Window-Value finden
                        for ($i=0; $vVector->has('WSR_WINDOWVALUE'.$i); $i++);
                        $newName = 'WSR_WINDOWVALUE'.$i;
                        $qVal->value = $qVal->getValueName();
                        $qVal->function = $_REQUEST['value'];
                        $vVector->rename($pos,'WSR_WINDOWVALUE'.$i);
                    }else{
                        
                        if ($qVal->isWindowValue()){
                            if ($vVector->has($qVal->getValueName())){
                                http_response_code(425);
                                echo WSRTranslate::translate('Der Wert wird schon direkt abgefragt').".\n"
                                    . WSRTranslate::translate('Dieser Eintrag kann nur gelöscht werden');
                                die();
                            }
                            $vVector->rename($pos,$qVal->getValueName());
                            $qVal->function = null;
                            $qVal->value = null;
                            return;
                        }
                        $qVal->function = null;
                        return;
                    }
                    
                    return;
            }
            break;
            
    }
}






http_response_code(425);
echo "Ungültiger Aufruf \n".var_dump($_REQUEST);
die();
