<?php
/**
 * Projekt: WS-Reporter
 *          Liste der Werte bei einem Filter vom Typ List bearbeiten
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    31.05.2022
 *
 */
require_once './includes/classes.inc';
// error_log("Called ersFilterList. action = ".$_POST['action']);
global $query;


function selectListe(){
    global $rf, $query, $dqFilter;
    leseRechteVerlangen();
    rechteAnwenden();
    // SQL für Liste Aufbauen;
    $sql = new SqlAbfrage('DWH');
    $mrf = $query->getReportMetaRecord($rf->getName());
    if (! isValid($mrf->selectFilterTable)){
        $mrf->selectFilterTable = $query->class_table;
    }
    
    if (substr($mrf->selectFilterTable, 0,1) == '#') $mrf->readSelectQuery();
    else $mrf->readSelectTable();
            
    return $mrf->getListOptions();
}


function echoListe(){
    global $rf, $query, $dqFilter;
    $liste = selectListe();
    echo "LISTE:";
    if ($rf->ausschlussListe) echo 'ausschlussListe';
    foreach ($liste as $z){
        $test = array_search($z[0], $rf->fs_list);
        if ($test !== false)
            echo "\n1\t".$z[0]."\t".$z[1];
            else echo "\n0\t".$z[0]."\t".$z[1];
    }
    
/* alt    
    while ($z = $stmt->fetch(PDO::FETCH_NUM)){
        $test = array_search($z[0], $rf->fs_list);
        if ($test !== false)
            echo "\n1\t".$z[0]."\t".$z[1];
        else echo "\n0\t".$z[0]."\t".$z[1];
    }
*/    
}

if (array_key_exists('pos', $_POST)){
    if (array_key_exists('tab', $_POST)){
        if ($_POST['tab'] == 'AddFilter') $rf = $query->addFilter->getPos($_POST['pos']);
        else if ($_POST['tab'] == 'Filter') $rf = $query->repFilter->getPos($_POST['pos']);
    }
    if (false) $rf = new RepFilter("DD");
}else {
    echo "FEHLER: Keine aktive Filterliste gefunden";
    die();
}


if ($rf == null) {
    echo "FEHLER: Aktive Filterliste nicht gefunden";
    die();
}

if ($_POST['action'] == 'AusschlussMode'){
    $rf->ausschlussListe = true;
    echo 'OK:';
    return;
}

if ($_POST['action'] == 'AuswahlMode'){
    $rf->ausschlussListe = false;
    echo 'OK:';
    return;
}


if ($_POST['action'] == 'auswählen'){
    $test = array_search($_POST['wert'], $rf->fs_list);
    if ($test === false){
        $rf->fs_list[] = $_POST['wert'];
        echo 'OK:';
    }else echo 'schon drin';
    return;
}

if ($_POST['action'] == 'allesAuswählen'){
    $stmt = selectListe();
    $rf->fs_list = array();
    echo "LISTE:";
    if ($rf->ausschlussListe) echo 'ausschlussListe';
    while ($z = $stmt->fetch(PDO::FETCH_NUM)){
        $rf->fs_list[] = $z[0];
        echo "\n1\t".$z[0]."\t".$z[1];
    }
    return;
}


if ($_POST['action'] == 'abwählen'){
    $test = array_search($_POST['wert'], $rf->fs_list);
    if ($test !== false){
        unset($rf->fs_list[$test]);
        $rf->fs_list = array_values($rf->fs_list);
        echo 'OK:';
    }else echo 'nicht ausgewählt';
    return;
}

if ($_POST['action'] == 'allesAbwählen'){
    $stmt = selectListe();
    $rf->fs_list = array();
    echo "LISTE:";
    if ($rf->ausschlussListe) echo 'ausschlussListe';    
    while ($z = $stmt->fetch(PDO::FETCH_NUM)){
        echo "\n0\t".$z[0]."\t".$z[1];
    }
    return;
}

if ($_POST['action'] == 'invertieren'){
    $stmt = selectListe();
    $alteListe = $rf->fs_list;
    $rf->fs_list = array();
//    error_log('Alte Liste:'.print_r($alteListe,true));
    echo "LISTE:";
    if ($rf->ausschlussListe) echo 'ausschlussListe';
    while ($z = $stmt->fetch(PDO::FETCH_NUM)){
        $test = array_search($z[0], $alteListe);
//        error_log("Serach ".$z[0].' ergibt '.$test);
        if ($test !== false)
            echo "\n0\t".$z[0]."\t".$z[1];
        else {
            $rf->fs_list[] = $z[0];
            echo "\n1\t".$z[0]."\t".$z[1];
        }
    }
    return;
}

if ($_POST['action'] == 'close'){
    if (array_key_exists('activeFilterList', $_SESSION))
        unset($_SESSION['activeFilterList']);
    return;
}



if ($_POST['action'] == 'bearbeiten'){
// HIER DATEN FÜR AUSWAHLLISTE ERSTELLEN,
// ausgewählte elemente stehen in $rf->fs_list
    if ( $rf->fs_list == null) $rf->fs_list = array();
    echoListe();
  return;  
}

if ($_POST['action'] == 'löschen'){
    $rf->fs_list = NULL;
    echo "Filter gelöscht";
    if (array_key_exists('activeFilterList', $_SESSION))
        unset($_SESSION['activeFilterList']);
    return;
}

echo "Action ist ungültig ".$_POST['action'];
die();
