/**
 * Projekt: WS-Reporter
 *			JavaScript für Reportspezifikation
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 * 
 *
 * call = editReport.php mit den Parametern id=requestID und table=requestTable
 */


function addJoin(pos){	
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=addJoin&pos="+pos);
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					load("Joins");
					load("Werte");
					load("Spalten");
					load("Filter");
					load("AddFilter");
					load("Hist");
				} else if (request.status == 425) {						
				  	alert("Fehler bei Add Join\n"+request.responseText);						
			   } else {
					alert("addJoin\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function addVar(wo,vn){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=Action&action=addVar&tab="+wo+"&var="+vn); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				load(wo);
				load('Hist');
				if (wo == "Zeilen") {
					load("Filter");
					load("Werte");
					load("AddFilter");
					load("Spalten");	
				}
				if (wo == "Spalten") {
					load("Zeilen");	
				}
				if (wo == "Werte") {
					load("Filter");	
				}
				if (wo == "Filter") {
					load("Spalten");	
					load("AddFilter");	
				}
			} else if (request.status == 425) {						
					  alert("Fehler beim Eintragen:\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("addVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}

function anleitung(level,part){
  win = open("./anleitung.php?level="+level+'&part='+encodeURIComponent(part),
  "WSRAnleitung",
  "width=900,height=700,screenX=500,screenY=300,scrollbars=yes");
}


function asNewReport(){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','Attribute');
	formData.append('attribute','neuerReport');
	formData.append('value',0);

	request.open("POST","./editReport.php");
	
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				  	alert(request.responseText);						
				} else if (request.status == 425) {						
				  	alert("Fehler bei als neuer Report\n"+request.responseText);						
			   } else {
					alert("als neuer Report\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}


function befehlAusführen(){
	var fo = document.getElementById("ReportForm");
	var target = fo.target;
	var id = fo.id.value;
	var repID = fo.reportID.value;
	var befehl = document.getElementById('befehl').value;
	if (befehl == "showSQL"){
		fo.action="./showSQL.php";
		fo.target="showSQL";
		fo.submit();		
	}else
	if (befehl == "neuerReport"){
		fo.action="./editReport.php";
		fo.report.value="neuer Report";
		fo.reportID.value=0;
		repID = 0;
		fo.target="";
		fo.id.value = null;
		fo.submit();
	}else
	if (befehl == "alsNeuerReport"){
		asNewReport();
		repID = 0;
	}else
	if (befehl == "editQuery"){
		fo.action="./editQuery.php";
		fo.target="QueryEditor";
		fo.id.value = null;
		fo.submit();
	}else
	if (befehl == "aktualisieren"){
		fo.action="./editReport.php";
		fo.report.value="";
		fo.reportID.value=0;
		fo.target="";
		fo.id.value = null;
		fo.submit();
	}else
	if (befehl == "dokumentieren"){
		fo.action="./reportReportDef.php";
		fo.target="ReportDok";
		fo.id.value = null;
		fo.submit();
	}else
	if (befehl == "freigeben"){
		release();
	}else
	if (befehl == "exportieren"){
		fo.action="./exportReportDef.php";
		fo.target="";
		fo.id.value = null;
		fo.submit();
	}else
	if (befehl == "getLink"){
		fo.action="./getLink.php";
		fo.target="";
		fo.id.value = null;
		fo.submit();
	}else
	if (befehl == "übersetzen"){
		fo.action="./translateReport.php";
		fo.target="Translate";
		fo.id.value = null;
		fo.submit();
	}else
	{
		alert ("Ungültiger Befehl: "+befehl);
	}
	fo.target = target;
	fo.id.value = id;
	fo.reportID.value = repID;
}

function closeMuster(wo){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=CloseMuster"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  if (wo == 201) load('Zeilen');		  
					  if (wo == 202) load('Spalten');		  
					  if (wo == 203) load('ReportVerweise');		  
			} else if (request.status == 425) {						
					  alert("Fehler beim Schließen der Muster-Auswahl\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("closeMuster\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}


function exportReportDef(reportID){
	var fo = document.getElementById("ReportForm");
	var target = fo.target;
	var report = fo.reportID.value;
	var id = fo.id.value;
	fo.action="./exportReportDef.php";
//	fo.method="POST";
	fo.target="";
	fo.id.value = null;
	fo.reportID.value = reportID;
	fo.submit();
	fo.reportID.value = report;
	fo.id.value = id;
	fo.target = target;
}

function deleteReport(reportID,title){
	if (confirm("Bitte bestätigen Sie das Löschen des Reports\n"+title)){
		var formData = new FormData();
		var request = new XMLHttpRequest();
		formData.append('id',requestID);
		formData.append('table',requestTable);
		formData.append('set','Action');
		formData.append('action','deleteReport');
		formData.append('reportID',reportID);
	
		request.open("POST","./editReport.php");
	
		request.addEventListener('load', function(event) {
	   	if (request.status == 200) {
				load("Reports");
		  }else if (request.status == 425) {
				alert("Fehler bei Report löschen\n"+request.responseText);
		  }else{
			  	alert("FEHLER: "+ request.responseText+"\n"+request.status+": "+request.statusText);						
						
		 }
		});
		request.send(formData);				
	}
}

function deleteVar(wo,pos){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=delete&tab="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				load(wo);
  				if (wo == "Zeilen") {
					load("Filter");
					load("AddFilter");
					load("Spalten");	
					load("Werte");
				}
				if (wo == "Spalten") {
					load("Zeilen");	
				}
  				if (wo == "Filter"){
					load("AddFilter");						
				}
			} else if (request.status == 425) {						
					  alert("Fehler beim Löschen:\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("delVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function release(){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','Attribute');
	formData.append('attribute','release');
	formData.append('value',0);

	request.open("POST","./editReport.php");
	
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				  	alert(request.responseText);						
				} else if (request.status == 425) {						
				  	alert("Fehler bei freigeben\n"+request.responseText);						
			   } else {
					alert("als freigeben\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}


function getQuellenDesc(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&get=QuellenDesc"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
			document.getElementById('QuellenDesc').innerHTML = request.responseText;
			} else if (request.status == 425) {						
					  alert("Fehler beim Laden der Quellen-Beschreibung:\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("delVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
	
}

function load(part){
	var request = new XMLHttpRequest();
	var ziel = document.getElementById("Spez"+part);
	if (ziel == null) return;
//	ziel.innerHTML ="Hole "+part+"-Selektor";
	request.open("GET",call+"&get="+part); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				ziel.innerHTML =  request.responseText;
				document.getElementById("Meldung").innerText="";
		 } else {
		      // console.warn
			alert("load "+part+"\n"+request.statusText+" "+ request.status+"\n"+request.responseText);
		   }
	});
	request.send();			
}


function loadReport(reportID){
	var fo = document.getElementById("ReportForm");
	var target = fo.target;
	var id = fo.id.value;
//	var reportID = fo.reportID.value;
	fo.action="./editReport.php";
	fo.action.value="reload";
	fo.reportID.value=reportID;
	fo.target="";
	fo.id.value = -1;
	fo.submit();
	fo.target = target;
	fo.id.value = id;
//	fo.reportID.value = reportID;
}
	
function moveUp(wo,pos){
	if (pos <= 0){
		alert("Aufwärts nicht möglich");
		return;
	}
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=moveUp&tab="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				load(wo);
			} else if (request.status == 425) {						
					  alert("Fehler bei aufwärts bewegen\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("moveUp\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}
function moveDown(wo,pos){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=moveDown&tab="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				load(wo);
			} else if (request.status == 425) {						
					  alert("Fehler bei abwärts bewegen\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("moveDown\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}

function moveTo(tab,vonPos,nachPos){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=moveTo&tab="+tab+"&pos="+vonPos+"&nachPos="+nachPos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				load(tab);
			} else if (request.status == 425) {						
					  alert("Fehler bei drag / drop\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("moveTo\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function moveToReport(tab,vonPos,nachPos){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=moveTo&tab="+tab+"&pos="+vonPos+"&nachPos="+nachPos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				document.getElementById('DisplayForm').submit();
			} else if (request.status == 425) {						
					  alert("Fehler bei drag / drop\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("moveTo\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}



function outputReport(){
	var fo = document.getElementById("ReportForm");
	var target = fo.target;
	var id = fo.id.value;
		fo.action="./outputReport.php";
		fo.target="ReportOutput";
		fo.report.value = document.getElementById('title').value;
		fo.submit();		

}


function saveReport(bestaetigt, asProd){
	var request = new XMLHttpRequest();
	var callA = call+"&set=Action&action=saveReport";
	if (bestaetigt) callA += "&bestaetigt=true";
	if (asProd) callA += "&asProd=true";
	request.open("GET",callA); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
			   alert("Der Report \""+title.value+"\" wurde gespeichert.");
				load("Reports");				
			}else
		   if (request.status == 201) {
			   document.getElementById("Meldung").innerText=request.responseText;
				alert(request.responseText+"\nDas Speichern muss noch exlizit bestätigt oder abgebrochen werden.");
			document.getElementById("saveStd").style.display="none";
			if (document.getElementById("saveProd") != null)
				document.getElementById("saveProd").style.display="none";
//			document.getElementById("saveClear").style.display="none";
			if (asProd) document.getElementById("saveCProd").style.display="inline";
			else document.getElementById("saveCStd").style.display="inline";
			document.getElementById("saveAbort").style.display="inline";
				return;
			}else
		    if (request.status == 425) {
			   document.getElementById("Meldung").innerHTML="FEHLER: "+ request.responseText;
				alert(request.responseText);
			}else{
			      // console.warn
				alert("saveReport\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			document.getElementById("saveStd").style.display="inline";
			if (document.getElementById("saveProd") != null)
				document.getElementById("saveProd").style.display="inline";
//			document.getElementById("saveClear").style.display="inline";
			if (document.getElementById("saveCProd") != null)
				document.getElementById("saveCProd").style.display="none";
			document.getElementById("saveCStd").style.display="none";
			document.getElementById("saveAbort").style.display="none";
			});
	request.send();				

}
	
var selFilterTab = null;
var selFilterPos = null;	
	
function createListTable(resp){
	var editorHTML = '<table><tr><th>Sel.</th><th>Wert</th></tr>';
	var zeilen = resp.split("\n");
	for (var z=1; z < zeilen.length; z++){
		var zeile = zeilen[z].split("\t");
		editorHTML += '<tr><th><input type="checkbox" onchange="filterSelect(\''+zeile[1]+'\',this.checked)" ';
		if (zeile[0] != '0'){
			editorHTML += ' checked '; 
		}
		editorHTML += '></th><td>'+zeile[2]+"</td></tr>\n"
	}
	editorHTML += '</table><br>';
	editorHTML += '<input type="checkbox" onchange="filterAusschlussliste(this.checked)" ';
	if (zeilen[0].substr(6,15) == 'ausschlussListe') 	editorHTML += ' checked ';
	editorHTML += '> Auschluss-Liste';
	editorHTML += '<br><br>';
	editorHTML += '<button onclick="filterList(\'allesAuswählen\')">alles auswählen</button>&nbsp;&nbsp;';
	editorHTML += '<button onclick="filterList(\'allesAbwählen\')">alles abwählen</button>&nbsp;&nbsp;';
	editorHTML += '<button onclick="filterList(\'invertieren\')">Auswahl invertieren</button>&nbsp;&nbsp;';
	editorHTML += '<button onclick="filterList(\'close\')">schließen</button>';
	return editorHTML;
}	
	
function setFilterList(tab,pos,action){
	var formData = new FormData();
	var request = new XMLHttpRequest();
//	console.log("Liste "+action.value);
	if (action.value == "bearbeiten"
	  || action.value == "löschen"){
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','FilterList');
	formData.append('action',action.value);
	formData.append('tab',tab);
	formData.append('pos',pos);
	request.open("POST","./editReport.php");
//	console.log('setFilterList '+action.value);
	request.addEventListener('load', function(event) {
    		if (request.status == 200) {
				var resp = request.responseText;
				var editorBox = document.getElementById('XSpezFilterList');
				if (resp.substring(0,6) == 'LISTE:'){
					editorBox.style.display = "block";		
					document.getElementById('SpezFilterList').innerHTML = createListTable(resp);
					selFilterTab = tab;
					selFilterPos = pos;
				}else {
					editorBox.style.display = "none";		
					alert(resp);					
					selFilterTab = null;
					selFilterPos = null;
					if (tab != 'AddFilter')load('AddFilter');
				}
				load(tab);
				load('Hist');
			} else if (request.status == 425) {						
				  	alert("Fehler bei Set Attribute\n"+request.responseText);						
		    } else {
				alert("setSet Attribute\n"+request.statusText+" "+ request.status
					+"\n"+request.responseText);
		   }
	});
	request.send(formData);					
	}
	
}	

function filterAusschlussliste(ausschluss){
	if (ausschluss) filterList ('AusschlussMode');
	else  filterList ('AuswahlMode');
}

function filterList(action){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','FilterList');
	formData.append('action',action);
	formData.append('tab',selFilterTab);
	formData.append('pos',selFilterPos);
	request.open("POST","./editReport.php");
//	console.log('filterList '+action);
	request.open("POST","./editReport.php");
	request.addEventListener('load', function(event) {
    		if (request.status == 200) {
				var resp = request.responseText;
				var editorBox = document.getElementById('XSpezFilterList');
				if (resp.substring(0,6) == 'LISTE:'){
					document.getElementById('SpezFilterList').innerHTML = createListTable(resp);
				}else if (action == 'close'){
					editorBox.style.display = "none";		
				}else if (resp == 'OK:'){
					return;
				}else {
					alert(resp);
				}
				load('Filter');
				load('AddFilter');
			} else if (request.status == 425) {						
				  	alert("Fehler bei Set Attribute\n"+request.responseText);						
		    } else {
				alert("setSet Attribute\n"+request.statusText+" "+ request.status
					+"\n"+request.responseText);
		   }
	});
	request.send(formData);						
}

function filterSelect(wert,selected){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','FilterList');
	formData.append('tab',selFilterTab);
	formData.append('pos',selFilterPos);
	if (selected) formData.append('action','auswählen');
	else formData.append('action','abwählen');
	formData.append('wert',wert);
	request.open("POST","./editReport.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				var resp = request.responseText;
				if (resp == 'OK:'){
				}else {
					alert(resp);
				}
				} else if (request.status == 425) {						
				  	alert("Fehler bei select Filter\n"+request.responseText);						
			   } else {
					alert("filterSelect\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}

	
function setSAttribute(attrib,value,target){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','Attribute');
	formData.append('attribute',attrib);
	formData.append('value',value);

	request.open("POST","./editReport.php");
	console.log('setAttribute '+attrib+'='+value);
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				console.log(attrib+"= "+value);
				load(target);
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set Attribute\n"+request.responseText);						
			   } else {
					alert("setSet Attribute\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}	
	
function setQAttribute(attrib,value){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','Attribute');
	formData.append('attribute',attrib);
	formData.append('value',value);

	request.open("POST","./editReport.php");
	
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				console.log(attrib+"= "+value);
					if (attrib == 'values_in_columns') {
						load("Werte");
						load("Spalten");
					} 
					else load("Title");
					if (attrib == 'title') 
						document.getElementById("ReportForm").report.value = value; 
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set Attribute\n"+request.responseText);						
			   } else {
					alert("setSet Attribute\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}	

function setPosAttribute(tab,pos,attrib,value){
	console.log('setPosAttribute '+tab+' '+pos+' '+attrib+' '+value);
	if (tab == 'Form'){
		/*
		* Der Filter wurde im Aufruf gesetzt und deshalb gibt es das Attribut in der Form
		*/ 
		var form = document.getElementById('FilterForm');
		if (form.elements['filter'+pos] != null){
			console.log('set form filter'+pos);
			if (form.elements['filter_'+pos+'_1'] != null){
				if (form.elements['filter_'+pos+'_2'].checked) {
					form.elements['filterValue'+pos+'V2'].value = form.elements['filter_'+pos+'_1'].value; 	
				}else{
					form.elements['filterValue'+pos+'V2'].value = form.elements['filter_'+pos+'_1'].value+' desc';
				}	
					form.elements['filterValue'+pos+'V1'].value = form.elements['filter_'+pos].value;
				console.log('set 1: '+form.setFilterValue2.value+' '+form.setFilterValue1.value)				
			}else{
				if (attrib == 'fs_von') form.elements['filterValue'+pos+'V1'].value = value;
				if (attrib == 'fs_bis') form.elements['filterValue'+pos+'V2'].value = value;
			}
			return;			
		}
		console.log("FEHLER bei Form-Set-Filter pos="+pos);
		return;
	}
	if (tab == 'Output'){
		/*
		 * Der Filter wurde noch nicht im Aufruf gesetzt. Deshalb wird 
	     * der Filter über die Parameter setFilter oder setFilter2 übergeben
         */
		var form = document.getElementById('FilterForm');
		console.log('make setFilter für '+pos);
		if (form.setFilter.value == pos || form.setFilter.value== ''){
			form.setFilter.value=pos;
			/* Anzeige-Filter muss neu gemacht werden
			if (form.elements['filter_'+pos+'_1'] != null){
				if (form.elements['filter_'+pos+'_2'].checked) {
					form.setFilterValue2.value = form.elements['filter_'+pos+'_1'].value; 	
				}else{
					form.setFilterValue2.value = form.elements['filter_'+pos+'_1'].value+' desc';
				}	
					form.setFilterValue1.value = form.elements['filter_'+pos].value;
				console.log('set 1: '+form.setFilterValue2.value+' '+form.setFilterValue1.value)				
			}else{
				if (attrib == 'wfWert') form.setFilterValue1.value = value;
				if (attrib == 'abSpalte') ;// GEHT NICHT!!
				if (attrib == 'wfAsc') form.setFilterValue1.value = value;
				if (attrib == 'wfType') form.setFilterValue1.value = value;
				
			*/	
				if (attrib == 'fs_von') form.setFilterValue1.value = value;
				if (attrib == 'fs_bis') form.setFilterValue2.value = value;				
			return;			
		}
		if (form.setFilter2.value == pos || form.setFilter2.value== ''){
			form.setFilter2.value=pos;
			if (form.elements['filter_'+pos+'_1'] != null){
				if (form.elements['filter_'+pos+'_2'].checked) {
					form.setFilter2Value2.value = form.elements['filter_'+pos+'_1'].value; 	
				}else{
					form.setFilter2Value2.value = form.elements['filter_'+pos+'_1'].value+' desc';
				}	
					form.setFilter2Value1.value = form.elements['filter_'+pos].value;
				console.log('set 1: '+form.setFilterValue2.value+' '+form.setFilterValue1.value)				
			}else{
				if (attrib == 'fs_von') form.setFilter2Value1.value = value;
				if (attrib == 'fs_bis') form.setFilter2Value2.value = value;
			}
			return;			
		}
		alert("Es können maximal zwei Auswahlen gesetzt bzw. geändert werden.\nAktualisieren Sie die Anzeige, um weitere Auswahlen zu ändern.");
		return;		
	}		
	if (tab == 'Check'){
		/*
		 * Es fehlt ein Required Filter, der hier gesetzt werden muss.
	     * Anzeige-Filter können hier nicht vorkommen 
		 */
		var form = document.getElementById('FilterForm2');
		if (form.setFilter.value == pos || form.setFilter.value== ''){
			form.setFilter.value=pos;
			if (attrib == 'fs_von') form.setFilterValue1.value = value;
			if (attrib == 'fs_bis') form.setFilterValue2.value = value;
			return;			
		}
		if (form.setFilter2.value == pos || form.setFilter2.value== ''){
			form.setFilter2.value=pos;
			if (attrib == 'fs_von') form.setFilter2Value1.value = value;
			if (attrib == 'fs_bis') form.setFilter2Value2.value = value;
			return;			
		}
		alert("Es können maximal zwei Auswahlen gesetzt bzw. geändert werden.\nAktualisieren Sie die Anzeige, um weitere Auswahlen zu ändern.");
		return;		
	}	
	/*
	 * Aufruf aus Report-Editor
     */	
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','ActionPos');
	formData.append('action','setAttribute');
	formData.append('tab',tab);
	formData.append('pos',pos);
	formData.append('attribute',attrib);
	formData.append('value',value);
	request.open("POST","./editReport.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				console.log(tab+": "+attrib+"= "+value);
					load(tab);
					if (tab == "Filter") {
						load('AddFilter');
						load('Hist');	
					}else if (tab = 'AddFilter'){
						load('Hist');						
					}
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set Attribute\n"+request.responseText);
					load(tab);						
			   } else {
					alert("setSet Attribute\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
}	


function setHistOption(quelle, dimension, wert){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=histOption&pos="+quelle+"&dimNr="+dimension+"&value="+wert);
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					var dateAbfrage = document.getElementById('HistDate'+quelle+'.'+dimension);
					if (dateAbfrage == null){
						console.log('FEHLER dateAbfrage HistDate'+quelle+'.'+dimension+' ist NULL');
						return;
					}
					if (wert == 6) dateAbfrage.style.display = 'inline';
					else dateAbfrage.style.display = 'none';
					console.log('setze  HistDate'+quelle+'.'+dimension+' auf '+dateAbfrage.style.display);
					
				} else if (request.status == 425) {						
				  	alert("Fehler bei Join-Prefix\n"+request.responseText);						
			   } else {
					alert("setJoinPrefix\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}

function setHistDatum(quelle, dimension, wert){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=histDate&pos="+quelle+"&dimNr="+dimension+"&value="+wert);
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					load("Joins");
				} else if (request.status == 425) {						
				  	alert("Fehler bei Join-Prefix\n"+request.responseText);						
			   } else {
					alert("setJoinPrefix\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();					
}


function setJoinPrefix(pos,prefix){
		/* ???????
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','ActionPos');
	formData.append('action','joinPrefix');
	formData.append('prefix',prefix);
	formData.append('pos',pos);
	request.open("POST","./editReport.php");
	*/
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=joinPrefix&pos="+pos+"&prefix="+encodeURIComponent(prefix));
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					load("Joins");
					load('Hist');
				} else if (request.status == 425) {						
				  	alert("Fehler bei Join-Prefix\n"+request.responseText);						
			   } else {
					alert("setJoinPrefix\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}


function setJoinType(pos,type){	
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=joinType&pos="+pos+"&type="+type);
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					load("Joins");
					load("Werte");
					load("Spalten");
				} else if (request.status == 425) {						
				  	alert("Fehler bei Join-Type\n"+request.responseText);						
			   } else {
					alert("setJoinType\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function removeJoin(pos){	
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=removeJoin&pos="+pos);
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					load("Joins");
					load("Werte");
					load("Spalten");
					load("Filter");
					load("AddFilter");
					load("Hist");
				} else if (request.status == 425) {						
				  	alert("Fehler bei remove Join\n"+request.responseText);						
			   } else {
					alert("setJoinPrefix\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function hideFoot(){
	document.getElementById("footLong").style.display = "none";
	document.getElementById("footShort").style.display = "inline";
}
function showFoot(){
	document.getElementById("footLong").style.display = "grid";
	document.getElementById("footShort").style.display = "none";
}


// UNVERÄNDERT
function showHide(target){
	console.log("ShowHide "+target);
	document.getElementById("XQuellenDesc").style.display="none";
	if (target == "Alle"){
		document.getElementById("XSpezZeilen").style.display="inline-block";
		document.getElementById("XSpezWerte").style.display="inline-block";
		document.getElementById("XSpezSpalten").style.display="inline-block";
		document.getElementById("XSpezFilter").style.display="inline-block";
		document.getElementById("XSpezAddFilter").style.display="inline-block";
		document.getElementById("XReportVerweise").style.display="inline-block";
		document.getElementById("XReports").style.display="table";
		if (document.getElementById("Xbr") != null)
			document.getElementById("Xbr").style.display="inline";
		if (document.getElementById("XSpezJoinVrz") != null)
			document.getElementById("XSpezJoinVrz").style.display="inline-block";
		if (document.getElementById("XSpezJoins") != null)
			document.getElementById("XSpezJoins").style.display="inline-block";
		if (document.getElementById("XSpezHist") != null)
			document.getElementById("XSpezHist").style.display="inline-block";
	}else{
		document.getElementById("XSpezZeilen").style.display="none";
		document.getElementById("XSpezWerte").style.display="none";
		document.getElementById("XSpezSpalten").style.display="none";
		document.getElementById("XSpezFilter").style.display="none";
		document.getElementById("XSpezAddFilter").style.display="none";
		document.getElementById("XReportVerweise").style.display="none";
		document.getElementById("XReports").style.display="none";
		if (document.getElementById("XSpezJoinVrz") != null)
			document.getElementById("XSpezJoinVrz").style.display="none";
		if (document.getElementById("XSpezHist") != null)
			document.getElementById("XSpezHist").style.display="none";
			
		document.getElementById(target).style.display="inline-block";

		if (target == "XReports" ){
			document.getElementById("XReports").style.display="table";
			if (document.getElementById("XSpezJoins") != null)
				document.getElementById("XSpezJoins").style.display="none";
		}else if (target == "XSpezFilter" ){
			document.getElementById("XSpezAddFilter").style.display="inline-block";
					if (document.getElementById("XSpezHist") != null)
			document.getElementById("XSpezHist").style.display="inline-block";
			
		}else if (target == "XReportVerweise" ){
			document.getElementById("XReportVerweise").style.display="table";
			if (document.getElementById("XSpezJoins") != null)
				document.getElementById("XSpezJoins").style.display="none";
		}else if (document.getElementById("XSpezJoins") != null){
				document.getElementById("XSpezJoins").style.display="inline-block";
 		}
		if (target == "XQuellenDesc" ){
			getQuellenDesc();
			if (document.getElementById("Xbr") != null)
			document.getElementById("Xbr").style.display="inline";
		}else	
		if (document.getElementById("Xbr") != null)
			document.getElementById("Xbr").style.display="none";
	}
	// document.getElementById("Meldung").innerText="";
}

function clearMeldung(){
 document.getElementById("Meldung").innerText="";
}

// ALTE FUNKTIONEN


/**
 Transaktionen zur Spezifikation des Reports
 */

function addRow(row){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=addRow&value="+row); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
					  loadSpalten();	
				  }else{
					  alert("Fehler beim Entfernen der Zeile\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("addRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function removeRow(row){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=delRow&value="+row); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
					  loadSpalten();	
				  }else{
					  alert("Fehler beim Entfernen der Zeile\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("removeRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function upRow(wert){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=upRow&value="+wert); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler beim Verschieben der Zeilenspalte\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("removeRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function downRow(wert){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=downRow&value="+wert); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler beim Verschieben der Zeilenspalte\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("downRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}




function setSummenZeile(checked,row){

	var request = new XMLHttpRequest();
	if (checked) 
		request.open("GET",call+"?program=addSummenZeile&value="+row); // ,false);
	else	
		request.open("GET",call+"?program=delSummenZeile&value="+row); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Summenzeile\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setSummenZeile\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setZeilenSortierung(sort,row){

	var request = new XMLHttpRequest();
		request.open("GET",call+"?program=setZeilenSortierung&sort="+sort+"&zeile="+row); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Zeilen-Sortierung\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setZeilenSortierung\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setFixLabelColumn(fix,row){

	var request = new XMLHttpRequest();
		request.open("GET",call+"?program=setZeileFixLabel&fix="+fix+"&zeile="+row); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Zeilen-Fixierung\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setFixLabelColumn\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

/* ALTEST ZEUG ???
function setZeilenLinkR(reportName,row){

	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setZeilenLinkReport&report="+encodeURIComponent(reportName)+"&zeile="+row); // ,false);
	
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Zeilen-Link\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setZeilenLinkR\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setZeileCopyFilter(checked,row){

	var request = new XMLHttpRequest();
	if (checked) 
		request.open("GET",call+"?program=setZeileCopyFilter&zeile="+row+"&copy=copy"); // ,false);
	else	
		request.open("GET",call+"?program=setZeileCopyFilter&zeile="+row); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Filter kopieren\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setZeileCopyFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}



function addValue(wert){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=addValue&value="+wert); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadWerte();
				  }else{
					  alert("Fehler beim Eintragen des Werts\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("addRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function removeValue(wert){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=delValue&value="+wert); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadWerte();
				  }else{
					  alert("Fehler beim Entfernen des Werts\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("removeValue\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function upValue(wert){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=upValue&value="+wert); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadWerte();
				  }else{
					  alert("Fehler beim Verschieben des Werts\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("removeValue\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function downValue(wert){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=downValue&value="+wert); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadWerte();
				  }else{
					  alert("Fehler beim Verschieben des Werts\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("removeValue\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}





function addFilter(filter){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=addFilter&filter="+filter); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadFilter();
				  }else{
					  alert("Fehler beim Eintragen des Filters\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("addFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function delFilter(filter){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=delFilter&filter="+filter); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadFilter();
				  }else{
					  alert("Fehler beim Löschen des Filters\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("addFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setFilterSelection(value,filter, pos){
	valueR = encodeURIComponent(value);
	console.log("Filter-Selection: ",valueR);
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setFilter&value="+valueR
		+"&filter="+filter+"&pos="+pos
	); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadFilter();
				  }else{
					  alert("Fehler beim Eintragen der Filter-Werte\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("addRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setFilterInTitle(pos, filter){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setFilterInTitle"
		+"&filter="+filter+"&pos="+pos
	); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadFilter();
				  }else{
					  alert("Fehler beim Eintragen der Filter-Werte\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("addRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}



function setFilterWirksam(abSpalte,filter){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setFilterabSpalte"
		+"&filter="+filter+"&abSpalte="+abSpalte
	); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadFilter();
				  }else{
					  alert("Fehler beim Eintragen der Filter-Werte\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("addRow\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}
*****/
function saveAbort(){
			document.getElementById("saveStd").style.display="inline";
			if (document.getElementById("saveProd") != null)
				document.getElementById("saveProd").style.display="inline";
//			document.getElementById("saveClear").style.display="inline";
			if (document.getElementById("saveCProd") != null)
				document.getElementById("saveCProd").style.display="none";
			document.getElementById("saveCStd").style.display="none";
			document.getElementById("saveAbort").style.display="none";
		   document.getElementById("Meldung").innerText="";
	
}





/* Altes Zeug ??
function setTitle(value){
	var request = new XMLHttpRequest();
	valueR = encodeURIComponent(value);
	request.open("GET",call+"?program=setTitle&title="+valueR); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					loadTitle();
				  }else{
					  alert("Fehler beim Eintragen des Titels\n"+request.responseText);						
					}			
				 }
			    else {
				alert("setTitle\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}

function setKommentar(value){
	var request = new XMLHttpRequest();
	valueR = encodeURIComponent(value);
	request.open("GET",call+"?program=setKommentar&kommentar="+valueR); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					loadTitle();
				  }else{
					  alert("Fehler beim Eintragen des Kommentars\n"+request.responseText);						
					}			
				 }
			    else {
				alert("setKommentar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}

function clearReport(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=clear"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {

				  if (request.responseText.substr(0,3) == "OK:"){
						loadZeilen();
						loadWerte();
						loadSpalten();
						loadFilter();
						loadTitle();
						loadJoins();
				  }else{
					  document.getElementById("Meldung").innerText="FEHLER: "+ request.responseText;						
					}			
				 }
			    else {
			      // console.warn
				alert("saveReport\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
//	var postData = new FormData();
//	postData.append("program","getSezPart");	
//	postData.append("abschnitt","SpezZeilen");	
	request.send();				
	
}

function setValueDisplay(display,value){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setValueDisplay&value="+value+"&display="+display); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadWerte();
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setValueDisplay\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}

function setColValDisplay(display,colGroup){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setColumnValueDisplay&colGroup="+colGroup+"&display="+display); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadWerte();
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setColValDisplay\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}


function setSpalten(value,colGroup){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setCols&reportCols="+value+"&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadZeilen();
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setSpalten\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}
function setSpaltenWerte(value,colGroup){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setColVals&reportColVals="+value+"&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setSpalten\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}

function setSpaltenLabel(value,colGroup){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setColLabel&label="+encodeURIComponent(value)+"&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setSpalten\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();					
}

function setSpaltenDescending(value,colGroup){
	var request = new XMLHttpRequest();
	var sort = "ascending";
	if (value) sort = "descending";
	request.open("GET",call+"?program=setColSort&sort="+sort+"&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setSpalten\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();					
}


function setSpaltenFilter(value,colGroup){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setColFilter&reportColFilter="+value+"&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setSpalten\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}
function setSpaltenFilterWert(value,pos,colGroup){
	var request = new XMLHttpRequest();
	valueR = encodeURIComponent(value);
	console.log(valueR);
	request.open("GET",call+"?program=setColFilterSpec&reportColFilterSpec="+valueR+"&pos="+pos+"&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
						loadSpalten();
				  }else{
					  alert("Fehler beim Eintragen\n"+request.responseText);						
					}			
				 }
			    else {
			      // console.warn
				alert("setSpalten\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	
}

function setSpaltenLinkR(reportName,colGroup){

	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setColumnReportLink&report="+encodeURIComponent(reportName)+"&colGroup="+colGroup); // ,false);
	
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Summenzeile\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setSummenZeile\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setSpalteCopyFilter(checked,colGroup){

	var request = new XMLHttpRequest();
	if (checked) 
		request.open("GET",call+"?program=setColumnCopyFilter&colGroup="+colGroup+"&copy=copy"); // ,false);
	else	
		request.open("GET",call+"?program=setColumnCopyFilter&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Filter kopieren\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setZeileCopyFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setSpalteLinkInValues(checked,colGroup){

	var request = new XMLHttpRequest();
	if (checked) 
		request.open("GET",call+"?program=setColumnLinkInValues&colGroup="+colGroup+"&linkInValues=LinkInValues"); // ,false);
	else	
		request.open("GET",call+"?program=setColumnLinkInValues&colGroup="+colGroup); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					  loadZeilen();
				  }else{
					  alert("Fehler bei Link in Spaltenkopf\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setZeileLinkInValues\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}


function setSortMode(mode){
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setSortMode&mode="+mode); 
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					loadTitle();
				  }else{
					  alert("Fehler bei Sortier-Option\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setCanSort\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}


function setFixLabelColumns(checked){
	
	var request = new XMLHttpRequest();
	if (checked) document.getElementById("canSort").checked=true;
	request.open("GET",call+"?program=setFixLabelColumns&fixColumns="+checked);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					loadTitle();
				  }else{
					  alert("Fehler bei Sortier-Option\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setCanSort\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setValuesInColumns(checked){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setValuesInColumns&valuesInColumns="+checked);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					loadZeilen();
					loadSpalten();
				  }else{
					  alert("Fehler bei Werte in Spalten\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setValuesInColumns\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setDisplayCharts(value){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setDisplayCharts&displayCharts="+value);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					loadTitle();
				  }else{
					  alert("Fehler bei Summen-Charts\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setDisplayCharts\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function setChartSize(size){
	
	var request = new XMLHttpRequest();
	request.open("GET",call+"?program=setChartSize&size="+size);
	request.addEventListener('load', function(event) {
		   if (request.status >= 200 && request.status < 300) {
				  if (request.responseText.substr(0,3) == "OK:"){
					loadTitle();
				  }else{
					  alert("Fehler bei Chart-Größe\n"+request.responseText);						
					}			
				 } else {
			      // console.warn
				alert("setChartSize\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

****/

function stop(){
	return false;
}


function showFilter(){
	var doc = document.getElementById('ShowFilter');
	if (doc != null){
		if (doc.style.display == 'inline-block'){
			 doc.style.display = 'none';
		}
		else {
			doc.style.display ='inline-block';	
		}
	}
}

function showReports(){
	var doc = document.getElementById('ShowReports');
	if (doc != null){
		if (doc.style.display == 'inline-block'){
			 doc.style.display = 'none';
		}
		else {
			doc.style.display ='inline-block';	
		}
	}
}

function unhideNewReport(){
	var o = document.getElementById('newReportOption');
	o.disabled = false;
	console.log('Unhide new report option');	
}

function updateValue(varName,row,value){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('varName',varName);
	formData.append('row',row);
	formData.append('value',value.trim());
	request.open("POST","./updateValue.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				console.log(varName+": "+row+"= "+value);
				} else if (request.status == 425) {						
				  	alert("Fehler beim Eintragen des Werts\n"+request.responseText);
			   } else {
					alert("updateValue\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);		
}

function updateColValue(varName,row,value,colNr,colValue){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('varName',varName);
	formData.append('row',row);
	formData.append('colNr',colNr);
	formData.append('colValue',colValue);
	formData.append('value',value.trim());
	request.open("POST","./updateValue.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				console.log(varName+": "+row+"= "+value);
				} else if (request.status == 425) {						
				  	alert("Fehler beim Eintragen des Werts\n"+request.responseText);
			   } else {
					alert("updateColValue\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);		
}



/**
	Für Joined Tables
 */





/**
	Für den Output
 */

 function sortiere (wert,richtung) {
 	var form = document.DisplayForm ; // document.getElementById("DisplayForm"); //document.DisplayForm ;
 	form.sortDir.value = richtung;	
 	form.sortVal.value = wert;	
 	form.sortCol.value = "";	
 	form.sortColVal.value = "";
 	form.submit();
 }

 function sortiereColumn (col,colValue,richtung) {
 	var form = document.DisplayForm ; // document.getElementById("DisplayForm"); //document.DisplayForm ;
 	form.sortDir.value = richtung;	
 	form.sortVal.value = "";	
 	form.sortCol.value = col;	
 	form.sortColVal.value = colValue;	
 	form.submit();
 }


function drawVBarChart(zelle, wert, min, max, color){
	 var c = document.getElementById(zelle);
/*
Fehlerbehandlung für Charts, wenn Charts nicht angezeigt werden.
Das kommt bei verknüpften Spalten vor, wenn die Filter nicht passen.
*/
if (c== null){
	console.log('FEHLER: Zelle '+zelle+' mit Wert '+wert+' nicht  gefunden.');
	return;
}
	c.style.height = chartSize;
	c.style.width = "2em";
	c.style.alignSelf = "center";
	m="1em";
	c.style.marginLeft = m;
	c.style.marginRight = m;
	c.style.marginTop = "2px";
	c.style.marginBottom = "0px";
	var ctx = c.getContext('2d');
	ctx.fillStyle = 'yellow';
//	ctx.fillRect(0, 0, c.width, c.height);
	var range = max - min; 
	ctx.fillStyle = color;
	if (wert > 0){
		ctx.fillRect(c.width * 0.1, (max - wert) / range * c.height, c.width * 0.8, (wert /range) * c.height);		
	}else{
		ctx.fillRect(c.width * 0.1, ( max/range) * c.height, c.width * 0.8, c.height *  (- wert / range));				
	}
		// Striche
	ctx.strokeStyle = "black";
	ctx.lineWidth=6;
	var step = -min/2;	
	if (max > -min) step = max/2;
	ctx.beginPath();
	ctx.moveTo(0, ( max/range) * c.height -2);
	ctx.lineTo(c.width, ( max/range) * c.height -2);
	ctx.stroke();
	ctx.lineWidth=4;
	if (max <= -min){
		ctx.beginPath();
		ctx.moveTo(0, c.height-2);
		ctx.lineTo(c.width, c.height- 2);
		ctx.stroke();		
	}
	if (step <= -min){
		ctx.beginPath();
		ctx.moveTo(0,( max + step)/range * c.height -2);
		ctx.lineTo(c.width,( max + step)/range * c.height -2);
		ctx.stroke();
	}
	if (step <= max){
		ctx.beginPath();
		ctx.moveTo(0, (max - step) / range  * c.height -2);
		ctx.lineTo(c.width,(max - step) / range  * c.height -2);
		ctx.stroke();
	}
	if (-min <= max){
		ctx.beginPath();
		ctx.moveTo(0, 2 );
		ctx.lineTo(c.width, 2 );
		ctx.stroke();
	}	
}

function drawHBarChart(zelle, wert, min, max, color){
	 var c = document.getElementById(zelle);
/*
Fehlerbehandlung für Charts, wenn Charts nicht angezeigt werden.
Das kommt bei verknüpften Spalten vor, wenn die Filter nicht passen.
*/
if (c== null){
	console.log('FEHLER: Zelle '+zelle+' mit Wert '+wert+' nicht  gefunden.');
	return;
}
//	console.log("HBar "+zelle+c);
	if(c == null) return;
//	 var t = document.getElementById("C"+zelle);
//	 c.width = t.offsetWidth - t.offsetParent.cellPadding * 2 - t.offsetParent.border * 2;
	c.style.height = "1em";
	c.style.width = chartSize;
//	c.style.alignSelf = "center";
	var m="3px";
	c.style.marginLeft = m;
	c.style.marginRight = m;
//	c.style.verticalAlign = "middle";
	var ctx = c.getContext('2d');
	ctx.fillStyle = 'yellow';
//	ctx.fillRect(0, 0, c.width, c.height);
	var range = max - min; 
	ctx.fillStyle = color;
	if (wert > 0){
		ctx.fillRect( (- min / range ) * c.width , c.height * 0.2, (wert / range) * c.width, c.height*0.6);		
	}else{
		ctx.fillRect( ((wert - min)  / range ) * c.width , c.height * 0.2, (- wert / range) * c.width, c.height*0.6);		
	}
	
	// Striche
	ctx.strokeStyle = "black";
	ctx.lineWidth=6;
	var step = -min/2;	
	if (max > -min) step = max/2;
	ctx.beginPath();
	if (( -min/range) * c.width > 2){
		ctx.moveTo(( -min/range) * c.width -2, 0);
		ctx.lineTo(( -min/range) * c.width -2, c.height);		
	}else{
		ctx.moveTo(1, 0);
		ctx.lineTo(1, c.height);				
	}
	ctx.stroke();
	ctx.strokeStyle = "gray";
	ctx.lineWidth=4;
	if (max <= -min){
		ctx.beginPath();
		ctx.moveTo(2, c.height * 0.1);
		ctx.lineTo(2, c.height * 0.9);
		ctx.stroke();		
	}
	if (step <= -min){
		ctx.beginPath();
		ctx.moveTo(( -min-step)/range * c.width -2, c.height * 0.1);
		ctx.lineTo(( -min-step)/range * c.width -2, c.height * 0.9);
		ctx.stroke();
	}
	if (step <= max){
		ctx.beginPath();
		ctx.moveTo(( (-min+step)/range) * c.width -2, c.height * 0.1);
		ctx.lineTo(( (-min+step)/range) * c.width -2, c.height * 0.9);
		ctx.stroke();
	}
	if (-min <= max){
		ctx.beginPath();
		ctx.moveTo( c.width -2, c.height * 0.1);
		ctx.lineTo( c.width -2, c.height * 0.9);
		ctx.stroke();
	}	
}


var farbenNode = null;
var farbenZiel = null;
function farbAuswahl(source,wertNr){
	if (farbenNode != null){
		
		farbenNode.parentNode.removeChild(farbenNode);
		farbenNode = null;
	}
	farbenZiel = source;
	node = document.createElement('p');
   source.parentNode.appendChild(node);
		node.style.position = 'absolute';
		node.style.display = 'block';
		node.style.backgroundColor = 'lightGray';
		node.style.left = (source.parentNode.getClientRects().x
			)
			+"px";
		node.style.top = (
			source.getClientRects().y
			)
			+"px";
		farbenNode = node;
	var erg = "Farbe wählen:<br><table>";
	var colnum = 0xffffff;
	var inc = new Array();
	inc[0] = 0x110000;
	inc[1] = 0x001100;
	inc[2] = 0x000011;
	inc[3] = 0x101000;
	inc[4] = 0x001010;
	inc[5] = 0x100010;
	inc[6] = 0x080808;
	inc[7] = 0x101010;
	for (c=0; c < inc.length; c++){
		erg += "<tr>";
		colnum = 0xffffff;

	
		for (i=0;i <13; i++){
			col = colnum.toString(16);
			erg += "<td style='background-color: #"+col+"' onclick='farbe(0x"+col+","+wertNr+")'>&nbsp;&nbsp;&nbsp;</td>";
			colnum -= inc[c];
		}
		erg += '</tr>';
	}
	erg += '</table>';
	node.innerHTML = erg;
			
		
}

function farbe(farbWahl,wertNr){
//	node.style.display = 'none';
	farbenNode.parentNode.removeChild(farbenNode);
	farbenNode = null;
//	farbenNode.display="none";
	farbenZiel.style.backgroundColor = '#'+farbWahl.toString(16);
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','ActionPos');
	formData.append('action','setAttribute');
	formData.append('tab','Werte');
	formData.append('pos',wertNr);
	formData.append('attribute','backgroundColor');
	formData.append('value','#'+farbWahl.toString(16));
	request.open("POST","./editReport.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				} else if (request.status == 425) {						
				  	alert("Fehler bei Set Background-Color\n"+request.responseText);
					load(tab);						
			   } else {
					alert("setSet Background-Color\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);					
	return;
}

/**
 * Drag and drop
 */

var oldColor = null;
var vonWo = null;
var vonPos = null;
function dragEnter(o){
}

function dragLeave(o){
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
}

function dragStart(event,wo,pos){
	vonWo = wo;
	vonPos = pos;
	event.dataTransfer.dropEffect = 'move';
 	event.effectAllowed = "move";
}

function drop(event,wo,pos,o){
	o = event.target;	
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
	moveTo(wo,vonPos,pos);			
}

function dragOver(event,wo,o){
	if (vonWo == wo) {
		if (! o.hasAttribute('backup_bColor')) {
			if (o.style.backgroundColor != null) o.setAttribute('backup_bColor', o.style.backgroundColor);
			else o.setAttribute('backup_bColor', '');
		}
		o.style.backgroundColor = '#aaff88';
		event.preventDefault();	
	}	
}

/**
 * Drag and Drop bei aktivem Editor
 */
function reportDrop(event,wo,pos,o){
	o = event.target;	
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
	moveToReport(wo,vonPos,pos);			
}

/**
 * Drag and Drop bei Output ohne aktivem Editor
 */
function outputDrop(event,wo,pos,o){
	o = event.target;	
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
	var form = document.DisplayForm; 
	form.WSM_addMove.value = wo;
	form.WSM_addMoveFrom.value = vonPos;
	form.WSM_addMoveTo.value = pos;
	form.submit();
}
