<?php
/**
 * Projekt: WS-Reporter
 *          SQL für Report-Erstellung anzeigen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 */
include 'includes/defender.inc';
// Ausgabe des SQL-Codes zur Fehlersuche
global $query, $meldungen;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/createReport.inc';
global $query, $wsReportVersion, $sourceSQL;
$meldungen = "";
$startZeit = hrtime(true);
$dump = false;

if (false) $query = new Query("dummy");
$query = null;
if (session_status() == PHP_SESSION_NONE)  session_start();

if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
}
session_abort();
if (array_key_exists('report', $_REQUEST)){
    if ($query == null || $query->title != $_REQUEST['report']){
        require_once './includes/loadReportDef.inc';
        loadReport($_REQUEST['report']);
    }
}
if ($query == null || $query->title != $_REQUEST['report']){
    echo "FEHLER:<br>Die Report-Defintion ".$_REQUEST['report']." konnte nicht geladen werden.";
    die();
}
anmeldungPruefen();
if (!dqAdminRechte()){
    http_response_code(425);
    echo "Für diese Operation sind die Administrator-Rechte \nfür die Datenquelle erforderlich";
    die;
}

/*****
 * Filter-Vektor aufbauen bzw. ergänzen.
 * @var Vector[RepFilter] $filterVector: enthält alle zusätzlich gesetzten Filter.
 *
 */
$filterVector = $query->addFilter;

if ($filterVector->size() > 0){
    for ($i=0; $i < $filterVector->size(); $i++){
        $fix = $filterVector->getPos($i);
        if ($fix->isSet()) $query->repFilter->put($fix);
    }
}

// FILTER aus Request
$addFilter = '';
if (array_key_exists('addFilter', $_REQUEST)){
    $addFilter.='&addFilter='.$_REQUEST['addFilter'];
    for ($i=0; $i < $_REQUEST['addFilter']; $i++){
        $addFilter.='&filter'.$i.'='.$_REQUEST['filter'.$i];
        $fn = $_REQUEST['filter'.$i];
        if ($query->repFilter->has($fn)){
            $f = $query->repFilter->get($fn);
            if (array_key_exists('filterValue'.$i.'V1', $_REQUEST)){
                $addFilter.='&filterValue'.$i.'V1='.$_REQUEST['filterValue'.$i.'V1'];
                $f->fs_von = $_REQUEST['filterValue'.$i.'V1'];
            }
            if (array_key_exists('filterValue'.$i.'V2', $_REQUEST)){
                $addFilter.='&filterValue'.$i.'V2='.$_REQUEST['filterValue'.$i.'V2'];
                $f->fs_bis = $_REQUEST['filterValue'.$i.'V2'];
            }
            //                $meldungen.='Zusatz-Filter '.$fn.' mit '. $f->fs_von.'<br>';
        }
        //        else $meldungen.= 'Kein Filter für '.$fn.' mit '.$_REQUEST['filterValue'.$i.'V1'].'<br>';
    }
}
if (array_key_exists('sortDir', $_REQUEST))  $addFilter.='&sortDir='.$_REQUEST['sortDir'];
if (array_key_exists('sortVal', $_REQUEST)) $addFilter.='&sortVal='.$_REQUEST['sortVal'];
if (array_key_exists('sortCol', $_REQUEST)) $addFilter.='&sortCol='.$_REQUEST['sortCol'];
if (array_key_exists('sortColVal', $_REQUEST)) $addFilter.='&sortColVal='.$_REQUEST['sortColVal'];

if (! array_key_exists('showTable', $_REQUEST)) $sourceSQL = true;

$meldungen ='';
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title><?=$query->outputTitlePrefix ?>: SQL für <?=$query->title?></title>
<meta name="GENERATOR" content="WS-PHP: showSQL.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/WSReport.css" >
</head> 
<body>
<h1>SQL für Report: <?=$query->title?></h1>
<?php if ($dump){?>
<div class="article white">
<pre>
<?php var_dump($query)?>
</pre>
</div>
<?php }?>
<div class="article white">
<h3>Base Table</h3>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>">SQL</a>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>&showTable=X">Tabelle</a>
<?php 
createHistory();
$sql = new SqlAbfrage('DWH'); 
createBasicQuery($sql,'base',-1, -1);
for ($i = 0; $i < $query->repTables->size(); $i++){
    if ($query->repTables->getPos($i)->joinType == JoinedTable::JOINSPALTEN){
        $sql->union();
        createBasicQuery($sql,$query->repTables->getPos($i)->kennzeichen,-1, -1);
        $sql->unionWeg();
    }
}
        
echo $meldungen;
$meldungen = '';
if (array_key_exists('showTable', $_REQUEST))  {
    $startZeit2 = hrtime(true);
    if (createTable('base', $sql))
        showTable('base');    
        echo '<br>Zeit: Basic Table '.number_format((hrtime(true)-$startZeit2)/1000000,0).'ms <br>';
//        echo '<pre>';var_dump($sql); echo '</pre>';
}
else echo '<pre>'.$sql->sql.'</pre>'; 
 
 
 
for ($i = 0; $i < $query->repTables->size(); $i++){
    if ($query->repTables->getPos($i)->joinType == JoinedTable::JOINWERTE
        || $query->repTables->getPos($i)->joinType == JoinedTable::JOINOUTERWERTE){
    $k = $query->repTables->getPos($i)->kennzeichen;
?><!--  -->
<h3>Table <?=$k ?> (<?=$query->repTables->getPos($i)->prefix ?>)</h3>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>">SQL</a>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>&showTable=X">Tabelle</a>
<?php 
$sql = new SqlAbfrage('DWH');
createBasicQuery($sql,$k,-1, -1);
echo $meldungen;
$meldungen = '';
if (array_key_exists('showTable', $_REQUEST))  {
    $startZeit2 = hrtime(true);
    if (createTable($k, $sql))
        showTable($k);
        echo '<br>Zeit: '.$query->repTables->getPos($i)->prefix.' '.number_format((hrtime(true)-$startZeit2)/1000000,0).'ms <br>';
}
else echo '<pre>'.$sql->sql.'</pre>';   
}
}
?><!--  -->
<h3>Tabellen-Zeilen und Spalten </h3>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>">SQL</a>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>&showTable=X">Tabelle</a>
<?php 
$sql = new SqlAbfrage('DWH');
createLeadTable($sql);
if (array_key_exists('showTable', $_REQUEST))  {
    $startZeit2 = hrtime(true);
    if (createTable('lead', $sql))
        showTable('lead');
        echo '<br>Zeit: Ergebnis '.number_format((hrtime(true)-$startZeit2)/1000000,0).'ms <br>';
}
else echo '<pre>'.$sql->sql.'</pre>';
?>
<h3>Ergebnis-Tabelle </h3>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>">SQL</a>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>&showTable=X">Tabelle</a>
<?php 
$sql = new SqlAbfrage('DWH');
createJoinedTable($sql);
if (array_key_exists('showTable', $_REQUEST))  {
    $startZeit2 = hrtime(true);
    if (createTable('ergebnis', $sql))
        showTable('ergebnis');
        echo '<br>Zeit: Ergebnis '.number_format((hrtime(true)-$startZeit2)/1000000,0).'ms <br>';
}
else echo '<pre>'.$sql->sql.'</pre>';
?>
<h3>Sortierte Tabelle </h3>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>">SQL</a>
<a href="./showSQL.php?report=<?=$query->title.$addFilter?>&showTable=X">Tabelle</a>
<?php 
$sql = new SqlAbfrage('DWH');
createSortedTable($sql,'ergebnis');
if (array_key_exists('showTable', $_REQUEST))  {
    $startZeit2 = hrtime(true);
    if (createTable('output', $sql))
        showTable('output');
        echo '<br>Zeit: Sortiertes Ergebnis '.number_format((hrtime(true)-$startZeit2)/1000000,0).'ms <br>';
        //        dumpTable('output');
        echo '<br>Zeit insgesamt: '.number_format((hrtime(true)-$startZeit)/1000000,0).'ms <br>';
}
else echo '<pre>'.$sql->sql.'</pre>';
?>
<script type="text/javascript" src="./jscss/tableHeader.js">
	</script>
<script type="text/javascript">
window.addEventListener('load', function() {
 	new TableHeader("base"); 	
	<?php 
	for ($i = 0; $i < $query->repTables->size(); $i++)
	    echo 'new TableHeader("'.$query->repTables->getPos($i)->kennzeichen.'");';	    
	?>
 	new TableHeader("ergebnis"); 	 
 	new TableHeader("output"); 	
 });

</script>

</div>
</body>
</html>
